"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createTempFileFromZip = void 0;
const Pfs = require("../../../util/misc/promisfied-fs");
const JsZipHelper = require("../../../util/misc/jszip-helper");
function createTempFileFromZip(zip) {
    return __awaiter(this, void 0, void 0, function* () {
        const tempZipPath = (yield Pfs.openTempFile({ prefix: "tempSymbolsZip", suffix: ".zip" })).path;
        yield JsZipHelper.writeZipToPath(tempZipPath, zip, "DEFLATE");
        return tempZipPath;
    });
}
exports.createTempFileFromZip = createTempFileFromZip;
