"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const commandline_1 = require("../../../util/commandline");
const apis_1 = require("../../../util/apis");
const interaction_1 = require("../../../util/interaction");
const util_1 = require("util");
const debug = require("debug")("appcenter-cli:commands:distribute:releases:list");
let ShowReleasesCommand = class ShowReleasesCommand extends commandline_1.AppCommand {
    run(client) {
        return __awaiter(this, void 0, void 0, function* () {
            const app = this.app;
            let releases;
            try {
                const httpRequest = yield interaction_1.out.progress("Loading list of releases...", apis_1.clientRequest((cb) => client.releasesOperations.list(app.ownerName, app.appName, {
                    publishedOnly: true,
                }, cb)));
                releases = httpRequest.result;
            }
            catch (error) {
                debug(`Failed to get list of releases for the application - ${util_1.inspect(error)}`);
                return commandline_1.failure(commandline_1.ErrorCodes.Exception, "failed to get list of releases for the application");
            }
            interaction_1.out.reportNewLineSeparatedArray([
                ["ID", "id"],
                ["Short Version", "shortVersion"],
                ["Version", "version"],
                ["Uploaded At", "uploadedAt", interaction_1.out.report.asDate],
            ], releases);
            return commandline_1.success();
        });
    }
};
ShowReleasesCommand = __decorate([
    commandline_1.help("Shows the list of all releases for the application")
], ShowReleasesCommand);
exports.default = ShowReleasesCommand;
