"use strict";
// Implementation of profile configure command
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const commandline_1 = require("../../util/commandline");
const interaction_1 = require("../../util/interaction");
const apis_1 = require("../../util/apis");
const format_profile_1 = require("./lib/format-profile");
let ProfileConfigureCommand = class ProfileConfigureCommand extends commandline_1.Command {
    constructor(args) {
        super(args);
    }
    run(client) {
        return __awaiter(this, void 0, void 0, function* () {
            const profile = yield interaction_1.out.progress("Getting current user profile...", apis_1.clientCall((cb) => client.users.get(cb)));
            const questions = [
                {
                    type: "input",
                    name: "displayName",
                    message: "Display name",
                    default: profile.displayName,
                },
            ];
            const answers = yield interaction_1.prompt.question(questions);
            const anyChanged = Object.keys(answers).some((k) => answers[k] !== profile[k]);
            if (anyChanged) {
                const updated = yield interaction_1.out.progress("Updating user profile...", apis_1.clientCall((cb) => client.users.update({ displayName: answers.displayName }, cb)));
                format_profile_1.reportProfile(updated);
            }
            else {
                interaction_1.out.text("No changes to profile");
            }
            return commandline_1.success();
        });
    }
};
ProfileConfigureCommand = __decorate([
    commandline_1.help("Update user information")
], ProfileConfigureCommand);
exports.default = ProfileConfigureCommand;
