"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AppValidator = void 0;
const path = require("path");
class AppValidator {
    constructor(appPath) {
        if (!appPath) {
            throw new Error("Argument appPath is required");
        }
        this.appPath = appPath;
    }
    static validate(appPath) {
        return __awaiter(this, void 0, void 0, function* () {
            const validator = new AppValidator(appPath);
            yield validator.validate();
        });
    }
    validate() {
        return __awaiter(this, void 0, void 0, function* () {
            if (!(this.isIosApp() || this.isAndroidApp())) {
                throw new Error("The application file must be either Android or iOS application");
            }
        });
    }
    isIosApp() {
        return path.extname(this.appPath) === ".ipa";
    }
    isAndroidApp() {
        return path.extname(this.appPath) === ".apk";
    }
}
exports.AppValidator = AppValidator;
