"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RunTestsDownloadResultCommand = void 0;
const run_tests_command_1 = require("./run-tests-command");
const commandline_1 = require("../../../util/commandline");
const help_messages_1 = require("./help-messages");
const downloadUtil = require("../../../util/misc/download");
class RunTestsDownloadResultCommand extends run_tests_command_1.RunTestsCommand {
    afterCompletion(client, testRun, streamingOutput) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.testOutputDir) {
                // Download json test result
                const testReport = yield client.test.getTestReport(testRun.testRunId, this.app.ownerName, this.app.appName);
                if (testReport.stats.artifacts) {
                    yield downloadUtil.downloadArtifacts(this, streamingOutput, this.testOutputDir, testRun.testRunId, testReport.stats.artifacts);
                    yield this.mergeTestArtifacts();
                }
            }
        });
    }
}
__decorate([
    commandline_1.help(help_messages_1.Messages.TestCloud.Arguments.TestOutputDir),
    commandline_1.longName("test-output-dir"),
    commandline_1.hasArg
], RunTestsDownloadResultCommand.prototype, "testOutputDir", void 0);
exports.RunTestsDownloadResultCommand = RunTestsDownloadResultCommand;
