"use strict";
//
// Custom credentials object for talking to AppCenter
//
Object.defineProperty(exports, "__esModule", { value: true });
exports.AppCenterClientCredentials = void 0;
const debug = require("debug")("appcenter-cli:util:apis:appcenter-client-credentials");
class AppCenterClientCredentials {
    constructor(getToken) {
        debug(`Constructor with getToken = ${getToken} of type ${typeof getToken}`);
        this.getToken = getToken;
    }
    signRequest(request, callback) {
        debug("Getting token for request");
        this.getToken()
            .then((token) => {
            debug(`got token ${token} of type ${typeof token}`);
            request.headers["x-api-token"] = token;
            callback(null);
        })
            .catch((err) => {
            debug("Token fetch failed, failing request");
            callback(err);
        });
    }
}
exports.AppCenterClientCredentials = AppCenterClientCredentials;
