/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a AADGroup.
 */
class AADGroup {
  /**
   * Create a AADGroup.
   * @property {uuid} aadGroupId The id of the aad group
   * @property {uuid} tenantId The id of the aad tenant
   * @property {string} displayName The display name of the aad group
   */
  constructor() {
  }

  /**
   * Defines the metadata of AADGroup
   *
   * @returns {object} metadata of AADGroup
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AADGroup',
      type: {
        name: 'Composite',
        className: 'AADGroup',
        modelProperties: {
          aadGroupId: {
            required: true,
            serializedName: 'aad_group_id',
            type: {
              name: 'String'
            }
          },
          tenantId: {
            required: true,
            serializedName: 'tenant_id',
            type: {
              name: 'String'
            }
          },
          displayName: {
            required: true,
            serializedName: 'display_name',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AADGroup;
