/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a AADTenantAddRequest.
 */
class AADTenantAddRequest {
  /**
   * Create a AADTenantAddRequest.
   * @property {uuid} userId The user wanting to add this tenant to the
   * organization, must be an admin of the organization
   * @property {uuid} aadTenantId The AAD tenant id
   * @property {string} displayName The name of the AAD Tenant
   */
  constructor() {
  }

  /**
   * Defines the metadata of AADTenantAddRequest
   *
   * @returns {object} metadata of AADTenantAddRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AADTenantAddRequest',
      type: {
        name: 'Composite',
        className: 'AADTenantAddRequest',
        modelProperties: {
          userId: {
            required: true,
            serializedName: 'user_id',
            type: {
              name: 'String'
            }
          },
          aadTenantId: {
            required: true,
            serializedName: 'aad_tenant_id',
            type: {
              name: 'String'
            }
          },
          displayName: {
            required: true,
            serializedName: 'display_name',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AADTenantAddRequest;
