/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a AccessKey.
 */
class AccessKey {
  /**
   * Create a AccessKey.
   * @property {string} [name] Key of access key
   * @property {string} [createdBy] Account name of creator.
   * @property {string} [description] Description of access key
   * @property {string} [friendlyName] Friendly name of access key
   * @property {number} [createdTime] Created time of access key
   * @property {number} [expires] Time of expiry of access key
   * @property {string} [id] Id of accessKey
   * @property {boolean} [isSession] Legacy property which indicate if
   * accessKey was created from session
   */
  constructor() {
  }

  /**
   * Defines the metadata of AccessKey
   *
   * @returns {object} metadata of AccessKey
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AccessKey',
      type: {
        name: 'Composite',
        className: 'AccessKey',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          createdBy: {
            required: false,
            serializedName: 'createdBy',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          friendlyName: {
            required: false,
            serializedName: 'friendlyName',
            type: {
              name: 'String'
            }
          },
          createdTime: {
            required: false,
            serializedName: 'createdTime',
            type: {
              name: 'Number'
            }
          },
          expires: {
            required: false,
            serializedName: 'expires',
            type: {
              name: 'Number'
            }
          },
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          isSession: {
            required: false,
            serializedName: 'isSession',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = AccessKey;
