/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a AddUserOKResponseItem.
 */
class AddUserOKResponseItem {
  /**
   * Create a AddUserOKResponseItem.
   * @property {string} [code] The code of the result
   * @property {boolean} [invitePending] Whether the has accepted the invite.
   * Available when an invite is pending, and the value will be "true".
   * @property {string} [message] The message of the result
   * @property {number} status The status code of the result
   * @property {string} [userEmail] The email of the user
   */
  constructor() {
  }

  /**
   * Defines the metadata of AddUserOKResponseItem
   *
   * @returns {object} metadata of AddUserOKResponseItem
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AddUserOKResponseItem',
      type: {
        name: 'Composite',
        className: 'AddUserOKResponseItem',
        modelProperties: {
          code: {
            required: false,
            serializedName: 'code',
            type: {
              name: 'String'
            }
          },
          invitePending: {
            required: false,
            serializedName: 'invite_pending',
            type: {
              name: 'Boolean'
            }
          },
          message: {
            required: false,
            serializedName: 'message',
            type: {
              name: 'String'
            }
          },
          status: {
            required: true,
            serializedName: 'status',
            type: {
              name: 'Number'
            }
          },
          userEmail: {
            required: false,
            serializedName: 'user_email',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AddUserOKResponseItem;
