/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Resource usage for a single Mobile Center service
 *
 */
class AggregatedBillingInformationUsageTestService {
  /**
   * Create a AggregatedBillingInformationUsageTestService.
   * @property {object} [currentUsagePeriod] Usage for a single period
   * @property {string} [currentUsagePeriod.startTime] Inclusive start time of
   * the usage period
   * @property {string} [currentUsagePeriod.endTime] Exclusive end time of the
   * usage period.
   * @property {object} [currentUsagePeriod.byAccount] A collection of named
   * numeric values
   * @property {object} [currentUsagePeriod.byApp] A collection of  named
   * numeric values grouped by app
   */
  constructor() {
  }

  /**
   * Defines the metadata of AggregatedBillingInformationUsageTestService
   *
   * @returns {object} metadata of AggregatedBillingInformationUsageTestService
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AggregatedBillingInformation_usage_testService',
      type: {
        name: 'Composite',
        className: 'AggregatedBillingInformationUsageTestService',
        modelProperties: {
          currentUsagePeriod: {
            required: false,
            serializedName: 'currentUsagePeriod',
            type: {
              name: 'Composite',
              className: 'AggregatedBillingInformationUsageTestServiceCurrentUsagePeriod'
            }
          }
        }
      }
    };
  }
}

module.exports = AggregatedBillingInformationUsageTestService;
