/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Repostiory object
 *
 */
class AlertBugTrackerRepo {
  /**
   * Create a AlertBugTrackerRepo.
   * @property {string} name
   * @property {string} url
   * @property {string} id
   * @property {string} [description]
   * @property {boolean} [privateProperty]
   * @property {object} [owner] Repository owner object
   * @property {string} [owner.name]
   * @property {string} [owner.id]
   * @property {string} [owner.login]
   */
  constructor() {
  }

  /**
   * Defines the metadata of AlertBugTrackerRepo
   *
   * @returns {object} metadata of AlertBugTrackerRepo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AlertBugTrackerRepo',
      type: {
        name: 'Composite',
        className: 'AlertBugTrackerRepo',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          url: {
            required: true,
            serializedName: 'url',
            type: {
              name: 'String'
            }
          },
          id: {
            required: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          privateProperty: {
            required: false,
            serializedName: 'private',
            type: {
              name: 'Boolean'
            }
          },
          owner: {
            required: false,
            serializedName: 'owner',
            type: {
              name: 'Composite',
              className: 'AlertBugTrackerRepoOwner'
            }
          }
        }
      }
    };
  }
}

module.exports = AlertBugTrackerRepo;
