/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Alerting webhook ping operation result
 *
 */
class AlertWebhookPingResult {
  /**
   * Create a AlertWebhookPingResult.
   * @property {string} requestId Unique request identifier for tracking
   * @property {number} responseStatusCode HTTP status code returned in
   * response from calling webhook
   * @property {string} [responseReason] Reason returned in response from
   * calling webhook
   */
  constructor() {
  }

  /**
   * Defines the metadata of AlertWebhookPingResult
   *
   * @returns {object} metadata of AlertWebhookPingResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AlertWebhookPingResult',
      type: {
        name: 'Composite',
        className: 'AlertWebhookPingResult',
        modelProperties: {
          requestId: {
            required: true,
            serializedName: 'request_id',
            type: {
              name: 'String'
            }
          },
          responseStatusCode: {
            required: true,
            serializedName: 'response_status_code',
            type: {
              name: 'Number'
            }
          },
          responseReason: {
            required: false,
            serializedName: 'response_reason',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AlertWebhookPingResult;
