/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Jira bugtracker specific settings
 *
 */
class AlertingJiraBugtrackerSettings {
  /**
   * Create a AlertingJiraBugtrackerSettings.
   * @property {string} [callbackUrl]
   * @property {string} ownerName
   * @property {string} type type of bugtracker. Possible values include:
   * 'github', 'vsts', 'jira'
   * @property {number} jiraProjectId
   * @property {string} jiraProjectName
   */
  constructor() {
  }

  /**
   * Defines the metadata of AlertingJiraBugtrackerSettings
   *
   * @returns {object} metadata of AlertingJiraBugtrackerSettings
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'jira',
      type: {
        name: 'Composite',
        className: 'AlertingJiraBugtrackerSettings',
        modelProperties: {
          callbackUrl: {
            required: false,
            serializedName: 'callback_url',
            type: {
              name: 'String'
            }
          },
          ownerName: {
            required: true,
            serializedName: 'owner_name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          jiraProjectId: {
            required: true,
            serializedName: 'jira_project_id',
            type: {
              name: 'Number'
            }
          },
          jiraProjectName: {
            required: true,
            serializedName: 'jira_project_name',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AlertingJiraBugtrackerSettings;
