/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Aggregated Billing Information for a user an the organizations in which the
 * user is an admin.
 *
 */
class AllAccountsAggregatedBillingInformation {
  /**
   * Create a AllAccountsAggregatedBillingInformation.
   * @property {object} [aggregatedBillings] Aggregated Billing Information for
   * a user or an organization
   * @property {string} [aggregatedBillings.version] Version of the Billing
   * Information schema
   * @property {string} [aggregatedBillings.timestamp] The ISO 8601 datetime of
   * last modification
   * @property {string} [aggregatedBillings.id] ID of the user or organization
   * @property {object} [aggregatedBillings.billingPlans] Billing Plans section
   * in the Billing Information
   * @property {object} [aggregatedBillings.billingPlans.buildService] Billing
   * Plans for a single service
   * @property {boolean}
   * [aggregatedBillings.billingPlans.buildService.canSelectTrialPlan] Can
   * customer select trial plan for that service (if it exists)?
   * @property {string}
   * [aggregatedBillings.billingPlans.buildService.lastTrialPlanExpirationTime]
   * Expiration time of the last selected trial plan. Will be null if trial
   * plan was not used.
   * @property {object}
   * [aggregatedBillings.billingPlans.buildService.currentBillingPeriod]
   * Billing plans for a given period
   * @property {string}
   * [aggregatedBillings.billingPlans.buildService.currentBillingPeriod.startTime]
   * Inclusive start of the period
   * @property {string}
   * [aggregatedBillings.billingPlans.buildService.currentBillingPeriod.endTime]
   * Exclusive end of the period.
   * @property {object}
   * [aggregatedBillings.billingPlans.buildService.currentBillingPeriod.byAccount]
   * Selection of a billing plan
   * @property {number}
   * [aggregatedBillings.billingPlans.buildService.currentBillingPeriod.byAccount.count]
   * Number of instances of the billing plan.
   * @property {object}
   * [aggregatedBillings.billingPlans.buildService.currentBillingPeriod.byAccount.plan]
   * Billing Plan
   * @property {string}
   * [aggregatedBillings.billingPlans.buildService.currentBillingPeriod.byAccount.plan.id]
   * The Billing Plan ID
   * @property {string}
   * [aggregatedBillings.billingPlans.buildService.currentBillingPeriod.byAccount.plan.version]
   * Version of the Billing Plan schema
   * @property {number}
   * [aggregatedBillings.billingPlans.buildService.currentBillingPeriod.byAccount.plan.price]
   * Price of the Billing Plan
   * @property {string}
   * [aggregatedBillings.billingPlans.buildService.currentBillingPeriod.byAccount.plan.paymentSource]
   * Service that receives payments for this billing plan. Possible values
   * include: 'None', 'AppCenter', 'GitHub', 'Xtc'
   * @property {string}
   * [aggregatedBillings.billingPlans.buildService.currentBillingPeriod.byAccount.plan.service]
   * Name of the service that the plan applies to. Possible values include:
   * 'Build', 'Test'
   * @property {object}
   * [aggregatedBillings.billingPlans.buildService.currentBillingPeriod.byAccount.plan.limits]
   * A collection of named numeric values
   * @property {object}
   * [aggregatedBillings.billingPlans.buildService.currentBillingPeriod.byAccount.plan.attributes]
   * Collection of attribute values.
   * @property {string}
   * [aggregatedBillings.billingPlans.buildService.currentBillingPeriod.byAccount.plan.parentId]
   * @property {object} [aggregatedBillings.billingPlans.testService] Billing
   * Plans for a single service
   * @property {boolean}
   * [aggregatedBillings.billingPlans.testService.canSelectTrialPlan] Can
   * customer select trial plan for that service (if it exists)?
   * @property {string}
   * [aggregatedBillings.billingPlans.testService.lastTrialPlanExpirationTime]
   * Expiration time of the last selected trial plan. Will be null if trial
   * plan was not used.
   * @property {object}
   * [aggregatedBillings.billingPlans.testService.currentBillingPeriod] Billing
   * plans for a given period
   * @property {string}
   * [aggregatedBillings.billingPlans.testService.currentBillingPeriod.startTime]
   * Inclusive start of the period
   * @property {string}
   * [aggregatedBillings.billingPlans.testService.currentBillingPeriod.endTime]
   * Exclusive end of the period.
   * @property {object}
   * [aggregatedBillings.billingPlans.testService.currentBillingPeriod.byAccount]
   * Selection of a billing plan
   * @property {number}
   * [aggregatedBillings.billingPlans.testService.currentBillingPeriod.byAccount.count]
   * Number of instances of the billing plan.
   * @property {object}
   * [aggregatedBillings.billingPlans.testService.currentBillingPeriod.byAccount.plan]
   * Billing Plan
   * @property {string}
   * [aggregatedBillings.billingPlans.testService.currentBillingPeriod.byAccount.plan.id]
   * The Billing Plan ID
   * @property {string}
   * [aggregatedBillings.billingPlans.testService.currentBillingPeriod.byAccount.plan.version]
   * Version of the Billing Plan schema
   * @property {number}
   * [aggregatedBillings.billingPlans.testService.currentBillingPeriod.byAccount.plan.price]
   * Price of the Billing Plan
   * @property {string}
   * [aggregatedBillings.billingPlans.testService.currentBillingPeriod.byAccount.plan.paymentSource]
   * Service that receives payments for this billing plan. Possible values
   * include: 'None', 'AppCenter', 'GitHub', 'Xtc'
   * @property {string}
   * [aggregatedBillings.billingPlans.testService.currentBillingPeriod.byAccount.plan.service]
   * Name of the service that the plan applies to. Possible values include:
   * 'Build', 'Test'
   * @property {object}
   * [aggregatedBillings.billingPlans.testService.currentBillingPeriod.byAccount.plan.limits]
   * A collection of named numeric values
   * @property {object}
   * [aggregatedBillings.billingPlans.testService.currentBillingPeriod.byAccount.plan.attributes]
   * Collection of attribute values.
   * @property {string}
   * [aggregatedBillings.billingPlans.testService.currentBillingPeriod.byAccount.plan.parentId]
   * @property {object} [aggregatedBillings.usage] Usage section in the Billing
   * Information
   * @property {object} [aggregatedBillings.usage.buildService] Resource usage
   * for a single Mobile Center service
   * @property {object}
   * [aggregatedBillings.usage.buildService.currentUsagePeriod] Usage for a
   * single period
   * @property {string}
   * [aggregatedBillings.usage.buildService.currentUsagePeriod.startTime]
   * Inclusive start time of the usage period
   * @property {string}
   * [aggregatedBillings.usage.buildService.currentUsagePeriod.endTime]
   * Exclusive end time of the usage period.
   * @property {object}
   * [aggregatedBillings.usage.buildService.currentUsagePeriod.byAccount] A
   * collection of named numeric values
   * @property {object}
   * [aggregatedBillings.usage.buildService.currentUsagePeriod.byApp] A
   * collection of  named numeric values grouped by app
   * @property {object} [aggregatedBillings.usage.testService] Resource usage
   * for a single Mobile Center service
   * @property {object}
   * [aggregatedBillings.usage.testService.currentUsagePeriod] Usage for a
   * single period
   * @property {string}
   * [aggregatedBillings.usage.testService.currentUsagePeriod.startTime]
   * Inclusive start time of the usage period
   * @property {string}
   * [aggregatedBillings.usage.testService.currentUsagePeriod.endTime]
   * Exclusive end time of the usage period.
   * @property {object}
   * [aggregatedBillings.usage.testService.currentUsagePeriod.byAccount] A
   * collection of named numeric values
   * @property {object}
   * [aggregatedBillings.usage.testService.currentUsagePeriod.byApp] A
   * collection of  named numeric values grouped by app
   * @property {string} [aggregatedBillings.azureSubscriptionId] Unique
   * identifier for the Azure subscription used for billing
   * @property {string} [aggregatedBillings.azureSubscriptionState] State of
   * the Azure subscription used for billing. Possible values include:
   * 'Enabled', 'Disabled', 'NotSet'
   */
  constructor() {
  }

  /**
   * Defines the metadata of AllAccountsAggregatedBillingInformation
   *
   * @returns {object} metadata of AllAccountsAggregatedBillingInformation
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AllAccountsAggregatedBillingInformation',
      type: {
        name: 'Composite',
        className: 'AllAccountsAggregatedBillingInformation',
        modelProperties: {
          aggregatedBillings: {
            required: false,
            serializedName: 'aggregatedBillings',
            type: {
              name: 'Composite',
              className: 'AllAccountsAggregatedBillingInformationAggregatedBillings'
            }
          }
        }
      }
    };
  }
}

module.exports = AllAccountsAggregatedBillingInformation;
