/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a AndroidModule.
 */
class AndroidModule {
  /**
   * Create a AndroidModule.
   * @property {string} name Name of the Android module
   * @property {boolean} [hasBundle] Module contains bundle settings
   * @property {array} [productFlavors] The product flavors of the Android
   * module
   * @property {array} [buildVariants] The detected build variants of the
   * Android module (matrix of product flavor + build type (debug|release))
   * @property {array} [buildTypes] The detected build types of the Android
   * module
   * @property {array} [buildConfigurations] The detected build configurations
   * of the Android module
   * @property {boolean} [isRoot] Whether the module is at the root level of
   * the project
   */
  constructor() {
  }

  /**
   * Defines the metadata of AndroidModule
   *
   * @returns {object} metadata of AndroidModule
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AndroidModule',
      type: {
        name: 'Composite',
        className: 'AndroidModule',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          hasBundle: {
            required: false,
            serializedName: 'hasBundle',
            type: {
              name: 'Boolean'
            }
          },
          productFlavors: {
            required: false,
            serializedName: 'productFlavors',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          buildVariants: {
            required: false,
            serializedName: 'buildVariants',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          buildTypes: {
            required: false,
            serializedName: 'buildTypes',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          buildConfigurations: {
            required: false,
            serializedName: 'buildConfigurations',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'AndroidModuleBuildConfigurationsItemElementType',
                  type: {
                    name: 'Composite',
                    className: 'AndroidModuleBuildConfigurationsItem'
                  }
              }
            }
          },
          isRoot: {
            required: false,
            serializedName: 'isRoot',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = AndroidModule;
