/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a ApiTokenClaim.
 */
class ApiTokenClaim {
  /**
   * Create a ApiTokenClaim.
   * @property {string} [claimType] Possible values include: 'user_email',
   * 'user_origin', 'app_owner_name', 'app_name', 'app_origin', 'app_os',
   * 'app_platform', 'app_secret'
   * @property {string} [claimValue]
   */
  constructor() {
  }

  /**
   * Defines the metadata of ApiTokenClaim
   *
   * @returns {object} metadata of ApiTokenClaim
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ApiTokenClaim',
      type: {
        name: 'Composite',
        className: 'ApiTokenClaim',
        modelProperties: {
          claimType: {
            required: false,
            serializedName: 'claim_type',
            type: {
              name: 'String'
            }
          },
          claimValue: {
            required: false,
            serializedName: 'claim_value',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ApiTokenClaim;
