/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a ApiTokenResponsev2.
 */
class ApiTokenResponsev2 {
  /**
   * Create a ApiTokenResponsev2.
   * @property {uuid} id The unique id (UUID) of the api token
   * @property {string} createdAt The creation time
   * @property {array} [scope] The token's scope. A list of allowed roles.
   * @property {string} [encryptedToken] The encrypted value of a token. This
   * value will only be returned for token of type in_app_update.
   * @property {string} [description] The description of the token
   */
  constructor() {
  }

  /**
   * Defines the metadata of ApiTokenResponsev2
   *
   * @returns {object} metadata of ApiTokenResponsev2
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ApiTokenResponsev2',
      type: {
        name: 'Composite',
        className: 'ApiTokenResponsev2',
        modelProperties: {
          id: {
            required: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          createdAt: {
            required: true,
            serializedName: 'created_at',
            type: {
              name: 'String'
            }
          },
          scope: {
            required: false,
            serializedName: 'scope',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          encryptedToken: {
            required: false,
            serializedName: 'encrypted_token',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ApiTokenResponsev2;
