/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a AppMembershipsResponse.
 */
class AppMembershipsResponse {
  /**
   * Create a AppMembershipsResponse.
   * @property {string} [appOrigin] The app's origin
   * @property {array} [memberships] An array of all ways a user has access to
   * the app, based on the app_memberships table.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AppMembershipsResponse
   *
   * @returns {object} metadata of AppMembershipsResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AppMembershipsResponse',
      type: {
        name: 'Composite',
        className: 'AppMembershipsResponse',
        modelProperties: {
          appOrigin: {
            required: false,
            serializedName: 'app_origin',
            type: {
              name: 'String'
            }
          },
          memberships: {
            required: false,
            serializedName: 'memberships',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'AppMembershipsResponseMembershipsItemElementType',
                  type: {
                    name: 'Composite',
                    className: 'AppMembershipsResponseMembershipsItem'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = AppMembershipsResponse;
