/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a AppMembershipsValidationResponse.
 */
class AppMembershipsValidationResponse {
  /**
   * Create a AppMembershipsValidationResponse.
   * @property {object} [excessAppMemberships]
   * @property {array} [excessAppMemberships.appUsersMemberships]
   * @property {array} [excessAppMemberships.distributionGroupMemberships]
   * @property {array} [excessAppMemberships.organizationAdminMemberships]
   * @property {array} [appUsersWithMissingMemberships]
   * @property {array} [distributionGroupUsersWithMissingMemberships]
   * @property {array} [organizationAdminsWithMissingMemberships]
   */
  constructor() {
  }

  /**
   * Defines the metadata of AppMembershipsValidationResponse
   *
   * @returns {object} metadata of AppMembershipsValidationResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AppMembershipsValidationResponse',
      type: {
        name: 'Composite',
        className: 'AppMembershipsValidationResponse',
        modelProperties: {
          excessAppMemberships: {
            required: false,
            serializedName: 'excess_app_memberships',
            type: {
              name: 'Composite',
              className: 'AppMembershipsValidationResponseExcessAppMemberships'
            }
          },
          appUsersWithMissingMemberships: {
            required: false,
            serializedName: 'app_users_with_missing_memberships',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'AppMembershipsValidationResponseAppUsersWithMissingMembershipsItemElementType',
                  type: {
                    name: 'Composite',
                    className: 'AppMembershipsValidationResponseAppUsersWithMissingMembershipsItem'
                  }
              }
            }
          },
          distributionGroupUsersWithMissingMemberships: {
            required: false,
            serializedName: 'distribution_group_users_with_missing_memberships',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'AppMembershipsValidationResponseDistributionGroupUsersWithMissingMembershipsItemElementType',
                  type: {
                    name: 'Composite',
                    className: 'AppMembershipsValidationResponseDistributionGroupUsersWithMissingMembershipsItem'
                  }
              }
            }
          },
          organizationAdminsWithMissingMemberships: {
            required: false,
            serializedName: 'organization_admins_with_missing_memberships',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'AppMembershipsValidationResponseOrganizationAdminsWithMissingMembershipsItemElementType',
                  type: {
                    name: 'Composite',
                    className: 'AppMembershipsValidationResponseOrganizationAdminsWithMissingMembershipsItem'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = AppMembershipsValidationResponse;
