/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a AppPatchRequest.
 */
class AppPatchRequest {
  /**
   * Create a AppPatchRequest.
   * @property {string} [description] A short text describing the app
   * @property {string} [displayName] The display name of the app
   * @property {string} [releaseType] A one-word descriptive release type value
   * that starts with a capital letter but is otherwise lowercase
   * @property {string} [name] The name of the app used in URLs
   * @property {string} [iconUrl] The string representation of the URL pointing
   * to the app's icon
   * @property {uuid} [iconAssetId] The uuid for the icon's asset id from ACFUS
   */
  constructor() {
  }

  /**
   * Defines the metadata of AppPatchRequest
   *
   * @returns {object} metadata of AppPatchRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AppPatchRequest',
      type: {
        name: 'Composite',
        className: 'AppPatchRequest',
        modelProperties: {
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          displayName: {
            required: false,
            serializedName: 'display_name',
            type: {
              name: 'String'
            }
          },
          releaseType: {
            required: false,
            serializedName: 'release_type',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          iconUrl: {
            required: false,
            serializedName: 'icon_url',
            type: {
              name: 'String'
            }
          },
          iconAssetId: {
            required: false,
            serializedName: 'icon_asset_id',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AppPatchRequest;
