/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a AppRepoResponse.
 */
class AppRepoResponse {
  /**
   * Create a AppRepoResponse.
   * @property {uuid} id The unique id (UUID) of the repository integration
   * @property {uuid} appId The unique id (UUID) of the app that this
   * repository integration belongs to
   * @property {string} repoUrl The absolute URL of the repository
   * @property {string} [repoProvider] The provider of the repository. Possible
   * values include: 'github', 'bitbucket', 'vsts', 'gitlab'
   * @property {uuid} userId The unique id (UUID) of the user who configured
   * the repository
   * @property {string} [installationId] Installation id from the provider
   * @property {string} [repoId] Repository id from the provider
   * @property {string} [externalUserId] User id from the provider
   * @property {uuid} [serviceConnectionId] The id of the service connection
   * stored in customer credential store
   */
  constructor() {
  }

  /**
   * Defines the metadata of AppRepoResponse
   *
   * @returns {object} metadata of AppRepoResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AppRepoResponse',
      type: {
        name: 'Composite',
        className: 'AppRepoResponse',
        modelProperties: {
          id: {
            required: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          appId: {
            required: true,
            serializedName: 'app_id',
            type: {
              name: 'String'
            }
          },
          repoUrl: {
            required: true,
            serializedName: 'repo_url',
            type: {
              name: 'String'
            }
          },
          repoProvider: {
            required: false,
            serializedName: 'repo_provider',
            type: {
              name: 'String'
            }
          },
          userId: {
            required: true,
            serializedName: 'user_id',
            type: {
              name: 'String'
            }
          },
          installationId: {
            required: false,
            serializedName: 'installation_id',
            type: {
              name: 'String'
            }
          },
          repoId: {
            required: false,
            serializedName: 'repo_id',
            type: {
              name: 'String'
            }
          },
          externalUserId: {
            required: false,
            serializedName: 'external_user_id',
            type: {
              name: 'String'
            }
          },
          serviceConnectionId: {
            required: false,
            serializedName: 'service_connection_id',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AppRepoResponse;
