/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a AppVersion.
 */
class AppVersion {
  /**
   * Create a AppVersion.
   * @property {string} appVersionId
   * @property {string} appId
   * @property {string} displayName
   * @property {string} appVersion
   * @property {string} [buildNumber]
   */
  constructor() {
  }

  /**
   * Defines the metadata of AppVersion
   *
   * @returns {object} metadata of AppVersion
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AppVersion',
      type: {
        name: 'Composite',
        className: 'AppVersion',
        modelProperties: {
          appVersionId: {
            required: true,
            serializedName: 'app_version_id',
            type: {
              name: 'String'
            }
          },
          appId: {
            required: true,
            serializedName: 'app_id',
            type: {
              name: 'String'
            }
          },
          displayName: {
            required: true,
            serializedName: 'display_name',
            type: {
              name: 'String'
            }
          },
          appVersion: {
            required: true,
            serializedName: 'app_version',
            type: {
              name: 'String'
            }
          },
          buildNumber: {
            required: false,
            serializedName: 'build_number',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AppVersion;
