/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Apple connection secrets
 *
 */
class AppleCertificateSecretDetailsResponse {
  /**
   * Create a AppleCertificateSecretDetailsResponse.
   * @property {string} id id of the shared connection
   * @property {string} [displayName] display name of shared connection
   * @property {string} credentialType the type of the credential. Possible
   * values include: 'credentials', 'certificate'
   * @property {boolean} [isValid] whether the credentials are valid or not
   * @property {boolean} [is2FA] if the account is a 2FA account or not
   * @property {object} data apple certificate secret details.
   * @property {string} [data.base64Certificate] The certificate contents in
   * base 64 encoded string
   * @property {string} [data.password] The password for the certificate
   * @property {string} [data.displayName] The display name (CN) of the
   * certificate
   * @property {string} [data.certificateValidityStartDate] The date-time from
   * which the certificate is valid
   * @property {string} [data.certificateValidityEndDate] The date-time till
   * which the certificate is valid
   * @property {string} serviceType Polymorphic Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of AppleCertificateSecretDetailsResponse
   *
   * @returns {object} metadata of AppleCertificateSecretDetailsResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'apple',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'serviceType',
          clientName: 'serviceType'
        },
        uberParent: 'AppleCertificateSecretDetailsResponse',
        className: 'AppleCertificateSecretDetailsResponse',
        modelProperties: {
          id: {
            required: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          displayName: {
            required: false,
            serializedName: 'displayName',
            type: {
              name: 'String'
            }
          },
          credentialType: {
            required: true,
            serializedName: 'credentialType',
            type: {
              name: 'String'
            }
          },
          isValid: {
            required: false,
            serializedName: 'isValid',
            type: {
              name: 'Boolean'
            }
          },
          is2FA: {
            required: false,
            serializedName: 'is2FA',
            type: {
              name: 'Boolean'
            }
          },
          data: {
            required: true,
            serializedName: 'data',
            type: {
              name: 'Composite',
              className: 'AppleCertificateSecretDetailsResponseData'
            }
          },
          serviceType: {
            required: true,
            serializedName: 'serviceType',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AppleCertificateSecretDetailsResponse;
