/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Apple connection secrets
 *
 */
class AppleConnectionSecretRequest {
  /**
   * Create a AppleConnectionSecretRequest.
   * @property {string} [displayName] display name of shared connection
   * @property {string} serviceType service type of shared connection can be
   * apple|gitlab|googleplay|jira|applecertificate. Possible values include:
   * 'apple', 'jira', 'googleplay', 'gitlab'
   * @property {string} credentialType Polymorphic Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of AppleConnectionSecretRequest
   *
   * @returns {object} metadata of AppleConnectionSecretRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'apple',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'credentialType',
          clientName: 'credentialType'
        },
        uberParent: 'AppleConnectionSecretRequest',
        className: 'AppleConnectionSecretRequest',
        modelProperties: {
          displayName: {
            required: false,
            serializedName: 'displayName',
            type: {
              name: 'String'
            }
          },
          serviceType: {
            required: true,
            serializedName: 'serviceType',
            type: {
              name: 'String'
            }
          },
          credentialType: {
            required: true,
            serializedName: 'credentialType',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AppleConnectionSecretRequest;
