/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The response of Multifactor login. This is a 30 day session token generated
 * by apple.
 *
 */
class AppleMultifactorLoginResponse {
  /**
   * Create a AppleMultifactorLoginResponse.
   * @property {string} [username] the apple developer account.
   * @property {string} [cookie] The 30-day session Token generated by apple
   * after successfully logging in with Multifactor authentication.
   * @property {string} [expires] The expiry date of the cookie generated by
   * apple
   */
  constructor() {
  }

  /**
   * Defines the metadata of AppleMultifactorLoginResponse
   *
   * @returns {object} metadata of AppleMultifactorLoginResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AppleMultifactorLoginResponse',
      type: {
        name: 'Composite',
        className: 'AppleMultifactorLoginResponse',
        modelProperties: {
          username: {
            required: false,
            serializedName: 'username',
            type: {
              name: 'String'
            }
          },
          cookie: {
            required: false,
            serializedName: 'cookie',
            type: {
              name: 'String'
            }
          },
          expires: {
            required: false,
            serializedName: 'expires',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AppleMultifactorLoginResponse;
