/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Apple details for fetching test flight groups from Apple Developer Portal.
 * pass either apple_id or bundle_identifier to get the test flight groups. if
 * both are passed than apple_id will take preference
 *
 */
class AppleTestFlightGroupRequest {
  /**
   * Create a AppleTestFlightGroupRequest.
   * @property {string} [username] The username for the Apple Developer
   * account.
   * @property {string} [password] The password for the Apple Developer
   * account.
   * @property {string} [appleId] apple_id of the app for which test flight
   * groups need to be fetched.
   * @property {string} [bundleIdentifier] apple_id of the app for which test
   * flight groups need to be fetched.
   * @property {string} [teamIdentifier] Identifier of the team to use when
   * logged in.
   * @property {string} [cookie] The 30-day session cookie for multi-factor
   * authentication backed accounts.
   * @property {string} [serviceConnectionId] The service_connection_id of the
   * stored Apple credentials instead of username, password.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AppleTestFlightGroupRequest
   *
   * @returns {object} metadata of AppleTestFlightGroupRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AppleTestFlightGroupRequest',
      type: {
        name: 'Composite',
        className: 'AppleTestFlightGroupRequest',
        modelProperties: {
          username: {
            required: false,
            serializedName: 'username',
            type: {
              name: 'String'
            }
          },
          password: {
            required: false,
            serializedName: 'password',
            type: {
              name: 'String'
            }
          },
          appleId: {
            required: false,
            serializedName: 'apple_id',
            type: {
              name: 'String'
            }
          },
          bundleIdentifier: {
            required: false,
            serializedName: 'bundle_identifier',
            type: {
              name: 'String'
            }
          },
          teamIdentifier: {
            required: false,
            serializedName: 'team_identifier',
            type: {
              name: 'String'
            }
          },
          cookie: {
            required: false,
            serializedName: 'cookie',
            type: {
              name: 'String'
            }
          },
          serviceConnectionId: {
            required: false,
            serializedName: 'service_connection_id',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AppleTestFlightGroupRequest;
