/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * An object containing a UUID for an architecture for an iOS app.
 *
 */
class ArchIdentifier {
  /**
   * Create a ArchIdentifier.
   * @property {string} architecture The architecture that the UUID belongs to,
   * i.e. armv7 or arm64.
   * @property {uuid} uuid The unique identifier.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ArchIdentifier
   *
   * @returns {object} metadata of ArchIdentifier
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ArchIdentifier',
      type: {
        name: 'Composite',
        className: 'ArchIdentifier',
        modelProperties: {
          architecture: {
            required: true,
            serializedName: 'architecture',
            type: {
              name: 'String'
            }
          },
          uuid: {
            required: true,
            serializedName: 'uuid',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ArchIdentifier;
