/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Audience Query definition.
 *
 */
class AudienceQueryDefinition {
  /**
   * Create a AudienceQueryDefinition.
   * @property {string} queryType Audience Query Type. Possible values include:
   * 'broadcast', 'user_ids', 'account_ids', 'install_ids'
   * @property {array} [identifiers] List of identifiers.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AudienceQueryDefinition
   *
   * @returns {object} metadata of AudienceQueryDefinition
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AudienceQueryDefinition',
      type: {
        name: 'Composite',
        className: 'AudienceQueryDefinition',
        modelProperties: {
          queryType: {
            required: true,
            serializedName: 'queryType',
            type: {
              name: 'Enum',
              allowedValues: [ 'broadcast', 'user_ids', 'account_ids', 'install_ids' ]
            }
          },
          identifiers: {
            required: false,
            serializedName: 'identifiers',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = AudienceQueryDefinition;
