/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Audience test result.
 *
 */
class AudienceTestResult {
  /**
   * Create a AudienceTestResult.
   * @property {string} [definition] Audience definition in OData format.
   * @property {object} [customProperties] Custom properties used in the
   * definition.
   * @property {number} [estimatedCount] Estimated audience size.
   * @property {number} [estimatedTotalCount] Estimated total audience size.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AudienceTestResult
   *
   * @returns {object} metadata of AudienceTestResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AudienceTestResult',
      type: {
        name: 'Composite',
        className: 'AudienceTestResult',
        modelProperties: {
          definition: {
            required: false,
            serializedName: 'definition',
            type: {
              name: 'String'
            }
          },
          customProperties: {
            required: false,
            serializedName: 'custom_properties',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'DevicePropertyTypeElementType',
                  type: {
                    name: 'Enum',
                    allowedValues: [ 'string', 'number', 'boolean', 'date_time' ]
                  }
              }
            }
          },
          estimatedCount: {
            required: false,
            serializedName: 'estimated_count',
            type: {
              name: 'Number'
            }
          },
          estimatedTotalCount: {
            required: false,
            serializedName: 'estimated_total_count',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = AudienceTestResult;
