/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a AuthApplicationPatchRequest.
 */
class AuthApplicationPatchRequest {
  /**
   * Create a AuthApplicationPatchRequest.
   * @property {string} [policyId]
   * @property {uuid} [scopeId]
   * @property {string} [scopeUrl]
   * @property {string} [id]
   * @property {string} [provider] Possible values include: 'AADB2C', 'Auth0',
   * 'Firebase', 'AAD'
   */
  constructor() {
  }

  /**
   * Defines the metadata of AuthApplicationPatchRequest
   *
   * @returns {object} metadata of AuthApplicationPatchRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AuthApplicationPatchRequest',
      type: {
        name: 'Composite',
        className: 'AuthApplicationPatchRequest',
        modelProperties: {
          policyId: {
            required: false,
            serializedName: 'policyId',
            type: {
              name: 'String'
            }
          },
          scopeId: {
            required: false,
            serializedName: 'scopeId',
            type: {
              name: 'String'
            }
          },
          scopeUrl: {
            required: false,
            serializedName: 'scopeUrl',
            type: {
              name: 'String'
            }
          },
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          provider: {
            required: false,
            serializedName: 'provider',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AuthApplicationPatchRequest;
