/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * A request containing information for creating a Auto Provisioning Config.
 *
 */
class AutoProvisioningConfigRequest {
  /**
   * Create a AutoProvisioningConfigRequest.
   * @property {string} [appleDeveloperAccountKey] A key to a secret in
   * customer-credential-store. apple_developer_account refers to the user's
   * developer account that is used to log into https://developer.apple.com.
   * Normally the user's email.
   * @property {string} [appleDistributionCertificateKey] A key to a secret in
   * customer-credential-store. distribution_certificate refers to the
   * customer's certificate (that holds the private key) that will be used to
   * sign the app.
   * @property {boolean} [allowAutoProvisioning] When *true* enables auto
   * provisioning
   */
  constructor() {
  }

  /**
   * Defines the metadata of AutoProvisioningConfigRequest
   *
   * @returns {object} metadata of AutoProvisioningConfigRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AutoProvisioningConfigRequest',
      type: {
        name: 'Composite',
        className: 'AutoProvisioningConfigRequest',
        modelProperties: {
          appleDeveloperAccountKey: {
            required: false,
            serializedName: 'apple_developer_account_key',
            type: {
              name: 'String'
            }
          },
          appleDistributionCertificateKey: {
            required: false,
            serializedName: 'apple_distribution_certificate_key',
            type: {
              name: 'String'
            }
          },
          allowAutoProvisioning: {
            required: false,
            serializedName: 'allow_auto_provisioning',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = AutoProvisioningConfigRequest;
