/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The current device availability (registered, available and maxmimum) for
 * iPhones, iPads, iPods and Watches from Apple Developer Portal
 *
 */
class AvailabilityOfDevicesResponse {
  /**
   * Create a AvailabilityOfDevicesResponse.
   * @property {object} iphones ...
   * @property {number} [iphones.registered]
   * @property {number} [iphones.available]
   * @property {number} [iphones.maximum]
   * @property {object} ipads ...
   * @property {number} [ipads.registered]
   * @property {number} [ipads.available]
   * @property {number} [ipads.maximum]
   * @property {object} ipods ...
   * @property {number} [ipods.registered]
   * @property {number} [ipods.available]
   * @property {number} [ipods.maximum]
   * @property {object} watches ...
   * @property {number} [watches.registered]
   * @property {number} [watches.available]
   * @property {number} [watches.maximum]
   */
  constructor() {
  }

  /**
   * Defines the metadata of AvailabilityOfDevicesResponse
   *
   * @returns {object} metadata of AvailabilityOfDevicesResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AvailabilityOfDevicesResponse',
      type: {
        name: 'Composite',
        className: 'AvailabilityOfDevicesResponse',
        modelProperties: {
          iphones: {
            required: true,
            serializedName: 'iphones',
            type: {
              name: 'Composite',
              className: 'AvailabilityOfDevicesResponseIphones'
            }
          },
          ipads: {
            required: true,
            serializedName: 'ipads',
            type: {
              name: 'Composite',
              className: 'AvailabilityOfDevicesResponseIpads'
            }
          },
          ipods: {
            required: true,
            serializedName: 'ipods',
            type: {
              name: 'Composite',
              className: 'AvailabilityOfDevicesResponseIpods'
            }
          },
          watches: {
            required: true,
            serializedName: 'watches',
            type: {
              name: 'Composite',
              className: 'AvailabilityOfDevicesResponseWatches'
            }
          }
        }
      }
    };
  }
}

module.exports = AvailabilityOfDevicesResponse;
