/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a AvailableVersionsDiagnostics.
 */
class AvailableVersionsDiagnostics {
  /**
   * Create a AvailableVersionsDiagnostics.
   * @property {array} [versions] List of available versions.
   * @property {number} [totalCount] The full number of versions across all
   * pages.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AvailableVersionsDiagnostics
   *
   * @returns {object} metadata of AvailableVersionsDiagnostics
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AvailableVersions_Diagnostics',
      type: {
        name: 'Composite',
        className: 'AvailableVersionsDiagnostics',
        modelProperties: {
          versions: {
            required: false,
            serializedName: 'versions',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          totalCount: {
            required: false,
            serializedName: 'total_count',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = AvailableVersionsDiagnostics;
