/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a AzureSubscriptionAddRequest.
 */
class AzureSubscriptionAddRequest {
  /**
   * Create a AzureSubscriptionAddRequest.
   * @property {uuid} subscriptionId The azure subscription id
   * @property {uuid} tenantId The tenant id of the azure subscription belongs
   * to
   * @property {string} subscriptionName The name of the azure subscription
   * @property {boolean} [isBilling] If the subscription is used for billing
   */
  constructor() {
  }

  /**
   * Defines the metadata of AzureSubscriptionAddRequest
   *
   * @returns {object} metadata of AzureSubscriptionAddRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureSubscriptionAddRequest',
      type: {
        name: 'Composite',
        className: 'AzureSubscriptionAddRequest',
        modelProperties: {
          subscriptionId: {
            required: true,
            serializedName: 'subscription_id',
            type: {
              name: 'String'
            }
          },
          tenantId: {
            required: true,
            serializedName: 'tenant_id',
            type: {
              name: 'String'
            }
          },
          subscriptionName: {
            required: true,
            serializedName: 'subscription_name',
            type: {
              name: 'String'
            }
          },
          isBilling: {
            required: false,
            serializedName: 'is_billing',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureSubscriptionAddRequest;
