/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a BillingInformationSearchResultsItem.
 */
class BillingInformationSearchResultsItem {
  /**
   * Create a BillingInformationSearchResultsItem.
   * @property {string} [accountId] The Account ID
   * @property {string} [accountName] The Account Name
   * @property {string} [billingInternalAccountId] The Billing Internal Account
   * ID
   * @property {string} [buildPlan] The ID of the Build Billing Plan
   * @property {string} [testPlan] The ID of the Test Billing Plan
   */
  constructor() {
  }

  /**
   * Defines the metadata of BillingInformationSearchResultsItem
   *
   * @returns {object} metadata of BillingInformationSearchResultsItem
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'BillingInformationSearchResultsItem',
      type: {
        name: 'Composite',
        className: 'BillingInformationSearchResultsItem',
        modelProperties: {
          accountId: {
            required: false,
            serializedName: 'accountId',
            type: {
              name: 'String'
            }
          },
          accountName: {
            required: false,
            serializedName: 'accountName',
            type: {
              name: 'String'
            }
          },
          billingInternalAccountId: {
            required: false,
            serializedName: 'billingInternalAccountId',
            type: {
              name: 'String'
            }
          },
          buildPlan: {
            required: false,
            serializedName: 'buildPlan',
            type: {
              name: 'String'
            }
          },
          testPlan: {
            required: false,
            serializedName: 'testPlan',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = BillingInformationSearchResultsItem;
