/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The information for a single iOS device
 *
 */
class Body {
  /**
   * Create a Body.
   * @property {string} udid The Unique Device IDentifier of the device
   * @property {string} model The model identifier of the device, in the format
   * iDeviceM,N
   * @property {string} [osBuild] The build number of the last known OS version
   * running on the device
   * @property {string} [osVersion] The last known OS version running on the
   * device
   * @property {string} [serial] The device's serial number. Always empty or
   * undefined at present.
   * @property {string} [imei] The device's International Mobile Equipment
   * Identity number. Always empty or undefined at present.
   * @property {string} [ownerId] The user ID of the device owner.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Body
   *
   * @returns {object} metadata of Body
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'body',
      type: {
        name: 'Composite',
        className: 'Body',
        modelProperties: {
          udid: {
            required: true,
            serializedName: 'udid',
            type: {
              name: 'String'
            }
          },
          model: {
            required: true,
            serializedName: 'model',
            type: {
              name: 'String'
            }
          },
          osBuild: {
            required: false,
            serializedName: 'os_build',
            type: {
              name: 'String'
            }
          },
          osVersion: {
            required: false,
            serializedName: 'os_version',
            type: {
              name: 'String'
            }
          },
          serial: {
            required: false,
            serializedName: 'serial',
            type: {
              name: 'String'
            }
          },
          imei: {
            required: false,
            serializedName: 'imei',
            type: {
              name: 'String'
            }
          },
          ownerId: {
            required: false,
            serializedName: 'owner_id',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = Body;
