/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a BodyIntuneDetails.
 */
class BodyIntuneDetails {
  /**
   * Create a BodyIntuneDetails.
   * @property {object} [secretJson]
   * @property {string} [secretJson.idToken] the id token of user
   * @property {string} [secretJson.refreshToken] the refresh token for user
   * @property {string} [secretJson.refreshTokenExpiry] the expiry of refresh
   * token
   * @property {object} [targetAudience]
   * @property {string} [targetAudience.name] display name for the target
   * audience/group
   * @property {object} [appCategory]
   * @property {string} [appCategory.name] display name for the app category
   * @property {string} [tenantId] tenant id of the intune store
   */
  constructor() {
  }

  /**
   * Defines the metadata of BodyIntuneDetails
   *
   * @returns {object} metadata of BodyIntuneDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'body_intune_details',
      type: {
        name: 'Composite',
        className: 'BodyIntuneDetails',
        modelProperties: {
          secretJson: {
            required: false,
            serializedName: 'secret_json',
            type: {
              name: 'Composite',
              className: 'BodyIntuneDetailsSecretJson'
            }
          },
          targetAudience: {
            required: false,
            serializedName: 'target_audience',
            type: {
              name: 'Composite',
              className: 'BodyIntuneDetailsTargetAudience'
            }
          },
          appCategory: {
            required: false,
            serializedName: 'app_category',
            type: {
              name: 'Composite',
              className: 'BodyIntuneDetailsAppCategory'
            }
          },
          tenantId: {
            required: false,
            serializedName: 'tenant_id',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = BodyIntuneDetails;
