/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Boolean property.
 *
 */
class BooleanProperty {
  /**
   * Create a BooleanProperty.
   * @property {string} type
   * @property {string} name
   * @property {boolean} value Boolean property value.
   */
  constructor() {
  }

  /**
   * Defines the metadata of BooleanProperty
   *
   * @returns {object} metadata of BooleanProperty
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'boolean',
      type: {
        name: 'Composite',
        className: 'BooleanProperty',
        modelProperties: {
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          name: {
            required: true,
            serializedName: 'name',
            constraints: {
              MaxLength: 128,
              Pattern: /^[a-zA-Z][a-zA-Z0-9\-_]*$/
            },
            type: {
              name: 'String'
            }
          },
          value: {
            required: true,
            serializedName: 'value',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = BooleanProperty;
