/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * branch configuration revision
 *
 */
class BranchConfigurationRevisionsItem {
  /**
   * Create a BranchConfigurationRevisionsItem.
   * @property {string} [id]
   * @property {number} [revision]
   * @property {string} [changedDate]
   * @property {string} [name]
   * @property {string} [changeType]
   * @property {string} [definitionUrl]
   * @property {object} [changedBy] user who made a change in branch
   * configuration
   * @property {string} [changedBy.displayName]
   * @property {string} [changedBy.url]
   */
  constructor() {
  }

  /**
   * Defines the metadata of BranchConfigurationRevisionsItem
   *
   * @returns {object} metadata of BranchConfigurationRevisionsItem
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'BranchConfigurationRevisionsItem',
      type: {
        name: 'Composite',
        className: 'BranchConfigurationRevisionsItem',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          revision: {
            required: false,
            serializedName: 'revision',
            type: {
              name: 'Number'
            }
          },
          changedDate: {
            required: false,
            serializedName: 'changedDate',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          changeType: {
            required: false,
            serializedName: 'changeType',
            type: {
              name: 'String'
            }
          },
          definitionUrl: {
            required: false,
            serializedName: 'definitionUrl',
            type: {
              name: 'String'
            }
          },
          changedBy: {
            required: false,
            serializedName: 'changedBy',
            type: {
              name: 'Composite',
              className: 'BranchConfigurationRevisionsItemChangedBy'
            }
          }
        }
      }
    };
  }
}

module.exports = BranchConfigurationRevisionsItem;
