/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a BuildTimelineRecord.
 */
class BuildTimelineRecord {
  /**
   * Create a BuildTimelineRecord.
   * @property {string} [id]
   * @property {string} [name]
   * @property {number} [order]
   * @property {number} [percentComplete]
   * @property {string} [currentOperation]
   * @property {string} [state]
   * @property {string} [result]
   * @property {number} [errorCount]
   * @property {number} [warningCount]
   * @property {array} [issues]
   * @property {string} [startTime]
   * @property {string} [finishTime]
   * @property {string} [type]
   */
  constructor() {
  }

  /**
   * Defines the metadata of BuildTimelineRecord
   *
   * @returns {object} metadata of BuildTimelineRecord
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'BuildTimelineRecord',
      type: {
        name: 'Composite',
        className: 'BuildTimelineRecord',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          order: {
            required: false,
            serializedName: 'order',
            type: {
              name: 'Number'
            }
          },
          percentComplete: {
            required: false,
            serializedName: 'percentComplete',
            type: {
              name: 'Number'
            }
          },
          currentOperation: {
            required: false,
            serializedName: 'currentOperation',
            type: {
              name: 'String'
            }
          },
          state: {
            required: false,
            serializedName: 'state',
            type: {
              name: 'String'
            }
          },
          result: {
            required: false,
            serializedName: 'result',
            type: {
              name: 'String'
            }
          },
          errorCount: {
            required: false,
            serializedName: 'errorCount',
            type: {
              name: 'Number'
            }
          },
          warningCount: {
            required: false,
            serializedName: 'warningCount',
            type: {
              name: 'Number'
            }
          },
          issues: {
            required: false,
            serializedName: 'issues',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'BuildTimelineRecordIssuesItemElementType',
                  type: {
                    name: 'Composite',
                    className: 'BuildTimelineRecordIssuesItem'
                  }
              }
            }
          },
          startTime: {
            required: false,
            serializedName: 'startTime',
            type: {
              name: 'String'
            }
          },
          finishTime: {
            required: false,
            serializedName: 'finishTime',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = BuildTimelineRecord;
