/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a CodePushReleaseModification.
 */
class CodePushReleaseModification {
  /**
   * Create a CodePushReleaseModification.
   * @property {string} [targetBinaryRange]
   * @property {string} [description]
   * @property {boolean} [isDisabled]
   * @property {boolean} [isMandatory]
   * @property {number} [rollout]
   */
  constructor() {
  }

  /**
   * Defines the metadata of CodePushReleaseModification
   *
   * @returns {object} metadata of CodePushReleaseModification
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CodePushReleaseModification',
      type: {
        name: 'Composite',
        className: 'CodePushReleaseModification',
        modelProperties: {
          targetBinaryRange: {
            required: false,
            serializedName: 'target_binary_range',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          isDisabled: {
            required: false,
            serializedName: 'is_disabled',
            type: {
              name: 'Boolean'
            }
          },
          isMandatory: {
            required: false,
            serializedName: 'is_mandatory',
            type: {
              name: 'Boolean'
            }
          },
          rollout: {
            required: false,
            serializedName: 'rollout',
            constraints: {
              InclusiveMaximum: 100,
              InclusiveMinimum: 1
            },
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = CodePushReleaseModification;
