/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a CodePushStatusMetricMetadata.
 */
class CodePushStatusMetricMetadata {
  /**
   * Create a CodePushStatusMetricMetadata.
   * @property {string} deploymentKey
   * @property {string} [label]
   * @property {string} [appVersion]
   * @property {string} [previousDeploymentKey]
   * @property {string} [previousLabelOrAppVersion]
   * @property {string} [status]
   * @property {string} [clientUniqueId]
   */
  constructor() {
  }

  /**
   * Defines the metadata of CodePushStatusMetricMetadata
   *
   * @returns {object} metadata of CodePushStatusMetricMetadata
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CodePushStatusMetricMetadata',
      type: {
        name: 'Composite',
        className: 'CodePushStatusMetricMetadata',
        modelProperties: {
          deploymentKey: {
            required: true,
            serializedName: 'deployment_key',
            type: {
              name: 'String'
            }
          },
          label: {
            required: false,
            serializedName: 'label',
            type: {
              name: 'String'
            }
          },
          appVersion: {
            required: false,
            serializedName: 'app_version',
            type: {
              name: 'String'
            }
          },
          previousDeploymentKey: {
            required: false,
            serializedName: 'previous_deployment_key',
            type: {
              name: 'String'
            }
          },
          previousLabelOrAppVersion: {
            required: false,
            serializedName: 'previous_label_or_app_version',
            type: {
              name: 'String'
            }
          },
          status: {
            required: false,
            serializedName: 'status',
            type: {
              name: 'String'
            }
          },
          clientUniqueId: {
            required: false,
            serializedName: 'client_unique_id',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = CodePushStatusMetricMetadata;
