/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a CommitDetailsListItem.
 */
class CommitDetailsListItem {
  /**
   * Create a CommitDetailsListItem.
   * @property {string} [sha] The commit SHA
   * @property {string} [url] The URL to the commit
   * @property {object} [commit]
   * @property {string} [commit.message] Commit message
   * @property {object} [commit.author]
   * @property {string} [commit.author.date] Date and time of the commit
   * @property {string} [commit.author.name] Author name
   * @property {string} [commit.author.email] Author's email
   */
  constructor() {
  }

  /**
   * Defines the metadata of CommitDetailsListItem
   *
   * @returns {object} metadata of CommitDetailsListItem
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CommitDetailsListItem',
      type: {
        name: 'Composite',
        className: 'CommitDetailsListItem',
        modelProperties: {
          sha: {
            required: false,
            serializedName: 'sha',
            type: {
              name: 'String'
            }
          },
          url: {
            required: false,
            serializedName: 'url',
            type: {
              name: 'String'
            }
          },
          commit: {
            required: false,
            serializedName: 'commit',
            type: {
              name: 'Composite',
              className: 'CommitDetailsListItemCommit'
            }
          }
        }
      }
    };
  }
}

module.exports = CommitDetailsListItem;
