/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a CrashFreeDevicePercentages.
 */
class CrashFreeDevicePercentages {
  /**
   * Create a CrashFreeDevicePercentages.
   * @property {number} [averagePercentage] Average percentage.
   * @property {array} [dailyPercentages] The crash-free percentage per day.
   */
  constructor() {
  }

  /**
   * Defines the metadata of CrashFreeDevicePercentages
   *
   * @returns {object} metadata of CrashFreeDevicePercentages
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CrashFreeDevicePercentages',
      type: {
        name: 'Composite',
        className: 'CrashFreeDevicePercentages',
        modelProperties: {
          averagePercentage: {
            required: false,
            serializedName: 'average_percentage',
            type: {
              name: 'Number'
            }
          },
          dailyPercentages: {
            required: false,
            serializedName: 'daily_percentages',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'CrashFreeDevicePercentagesDailyPercentagesItemElementType',
                  type: {
                    name: 'Composite',
                    className: 'CrashFreeDevicePercentagesDailyPercentagesItem'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = CrashFreeDevicePercentages;
