/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a CrashesOverallItem.
 */
class CrashesOverallItem {
  /**
   * Create a CrashesOverallItem.
   * @property {string} [crashGroupId]
   * @property {string} [appVersion]
   * @property {object} [overall]
   * @property {number} [overall.crashCount]
   * @property {number} [overall.deviceCount]
   */
  constructor() {
  }

  /**
   * Defines the metadata of CrashesOverallItem
   *
   * @returns {object} metadata of CrashesOverallItem
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CrashesOverallItem',
      type: {
        name: 'Composite',
        className: 'CrashesOverallItem',
        modelProperties: {
          crashGroupId: {
            required: false,
            serializedName: 'crash_group_id',
            type: {
              name: 'String'
            }
          },
          appVersion: {
            required: false,
            serializedName: 'app_version',
            type: {
              name: 'String'
            }
          },
          overall: {
            required: false,
            serializedName: 'overall',
            type: {
              name: 'Composite',
              className: 'CrashesOverallItemOverall'
            }
          }
        }
      }
    };
  }
}

module.exports = CrashesOverallItem;
