/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a CreateAccessKeyRequest.
 */
class CreateAccessKeyRequest {
  /**
   * Create a CreateAccessKeyRequest.
   * @property {string} [createdBy] Name of creator current access key
   * @property {string} [friendlyName] Friendly name of the access key
   * @property {number} [ttl] Time to live of the access key
   */
  constructor() {
  }

  /**
   * Defines the metadata of CreateAccessKeyRequest
   *
   * @returns {object} metadata of CreateAccessKeyRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CreateAccessKeyRequest',
      type: {
        name: 'Composite',
        className: 'CreateAccessKeyRequest',
        modelProperties: {
          createdBy: {
            required: false,
            serializedName: 'createdBy',
            type: {
              name: 'String'
            }
          },
          friendlyName: {
            required: false,
            serializedName: 'friendlyName',
            type: {
              name: 'String'
            }
          },
          ttl: {
            required: false,
            serializedName: 'ttl',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = CreateAccessKeyRequest;
