/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a CreateAccessKeyResponse.
 */
class CreateAccessKeyResponse {
  /**
   * Create a CreateAccessKeyResponse.
   * @property {object} [accessKey]
   * @property {string} [accessKey.name] Key of access key
   * @property {string} [accessKey.createdBy] Account name of creator.
   * @property {string} [accessKey.description] Description of access key
   * @property {string} [accessKey.friendlyName] Friendly name of access key
   * @property {number} [accessKey.createdTime] Created time of access key
   * @property {number} [accessKey.expires] Time of expiry of access key
   * @property {string} [accessKey.id] Id of accessKey
   * @property {boolean} [accessKey.isSession] Legacy property which indicate
   * if accessKey was created from session
   */
  constructor() {
  }

  /**
   * Defines the metadata of CreateAccessKeyResponse
   *
   * @returns {object} metadata of CreateAccessKeyResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CreateAccessKeyResponse',
      type: {
        name: 'Composite',
        className: 'CreateAccessKeyResponse',
        modelProperties: {
          accessKey: {
            required: false,
            serializedName: 'accessKey',
            type: {
              name: 'Composite',
              className: 'CreateAccessKeyResponseAccessKey'
            }
          }
        }
      }
    };
  }
}

module.exports = CreateAccessKeyResponse;
