/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * A response containing information pertaining to starting a release upload
 * process
 *
 */
class CreateCreatedResponse {
  /**
   * Create a CreateCreatedResponse.
   * @property {string} uploadId The ID for the current upload
   * @property {string} uploadUrl The URL where the client needs to upload the
   * release to
   * @property {string} [assetId] The ID for the current upload, reserved for
   * future use
   * @property {string} [assetDomain] The URL for the current upload, reserved
   * for future use
   * @property {string} [assetToken] The token for the current upload, reserved
   * for future use
   */
  constructor() {
  }

  /**
   * Defines the metadata of CreateCreatedResponse
   *
   * @returns {object} metadata of CreateCreatedResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CreateCreatedResponse',
      type: {
        name: 'Composite',
        className: 'CreateCreatedResponse',
        modelProperties: {
          uploadId: {
            required: true,
            serializedName: 'upload_id',
            type: {
              name: 'String'
            }
          },
          uploadUrl: {
            required: true,
            serializedName: 'upload_url',
            type: {
              name: 'String'
            }
          },
          assetId: {
            required: false,
            serializedName: 'asset_id',
            type: {
              name: 'String'
            }
          },
          assetDomain: {
            required: false,
            serializedName: 'asset_domain',
            type: {
              name: 'String'
            }
          },
          assetToken: {
            required: false,
            serializedName: 'asset_token',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = CreateCreatedResponse;
