/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a CreateStoreSecretRequest.
 */
class CreateStoreSecretRequest {
  /**
   * Create a CreateStoreSecretRequest.
   * @property {object} [secretJson]
   * @property {string} [secretJson.idToken] the id token of user
   * @property {string} [secretJson.refreshToken] the refresh token for user
   * @property {string} [secretJson.refreshTokenExpiry] the expiry of refresh
   * token
   * @property {string} [tenantId] the tenant id for user
   */
  constructor() {
  }

  /**
   * Defines the metadata of CreateStoreSecretRequest
   *
   * @returns {object} metadata of CreateStoreSecretRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CreateStoreSecretRequest',
      type: {
        name: 'Composite',
        className: 'CreateStoreSecretRequest',
        modelProperties: {
          secretJson: {
            required: false,
            serializedName: 'secret_json',
            type: {
              name: 'Composite',
              className: 'CreateStoreSecretRequestSecretJson'
            }
          },
          tenantId: {
            required: false,
            serializedName: 'tenant_id',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = CreateStoreSecretRequest;
