/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a DataResourceTokenResponse.
 */
class DataResourceTokenResponse {
  /**
   * Create a DataResourceTokenResponse.
   * @property {string} [databaseId]
   * @property {string} [databaseName]
   * @property {string} [collectionName]
   * @property {string} [accountName]
   * @property {string} [token]
   * @property {date} [expiresOn]
   * @property {boolean} [isReadOnlyToken]
   */
  constructor() {
  }

  /**
   * Defines the metadata of DataResourceTokenResponse
   *
   * @returns {object} metadata of DataResourceTokenResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DataResourceTokenResponse',
      type: {
        name: 'Composite',
        className: 'DataResourceTokenResponse',
        modelProperties: {
          databaseId: {
            required: false,
            serializedName: 'databaseId',
            type: {
              name: 'String'
            }
          },
          databaseName: {
            required: false,
            serializedName: 'databaseName',
            type: {
              name: 'String'
            }
          },
          collectionName: {
            required: false,
            serializedName: 'collectionName',
            type: {
              name: 'String'
            }
          },
          accountName: {
            required: false,
            serializedName: 'accountName',
            type: {
              name: 'String'
            }
          },
          token: {
            required: false,
            serializedName: 'token',
            type: {
              name: 'String'
            }
          },
          expiresOn: {
            required: false,
            serializedName: 'expiresOn',
            type: {
              name: 'DateTime'
            }
          },
          isReadOnlyToken: {
            required: false,
            serializedName: 'isReadOnlyToken',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = DataResourceTokenResponse;
