/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a DataSubjectRightCustomerIdRequest.
 */
class DataSubjectRightCustomerIdRequest {
  /**
   * Create a DataSubjectRightCustomerIdRequest.
   * @property {string} [dataSubjectIdentifier] customer account id (b2c
   * identifier) / customer user id (free form text) depending on the value of
   * the fied `type`
   * @property {string} [type] type of the customer dataSubjectIdentifier.
   * Possible values include: 'CustomerAccountId', 'CustomerUserId'
   */
  constructor() {
  }

  /**
   * Defines the metadata of DataSubjectRightCustomerIdRequest
   *
   * @returns {object} metadata of DataSubjectRightCustomerIdRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DataSubjectRightCustomerIdRequest',
      type: {
        name: 'Composite',
        className: 'DataSubjectRightCustomerIdRequest',
        modelProperties: {
          dataSubjectIdentifier: {
            required: false,
            serializedName: 'dataSubjectIdentifier',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            serializedName: 'type',
            type: {
              name: 'Enum',
              allowedValues: [ 'CustomerAccountId', 'CustomerUserId' ]
            }
          }
        }
      }
    };
  }
}

module.exports = DataSubjectRightCustomerIdRequest;
