/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a DataSubjectRightUpdateStatusOperation.
 */
class DataSubjectRightUpdateStatusOperation {
  /**
   * Create a DataSubjectRightUpdateStatusOperation.
   * @property {string} requestId Request identifier of the operation
   * @property {string} status Operation status. Possible values include:
   * 'None', 'Created', 'Queued', 'InProgress', 'Completed', 'Failed'
   * @property {string} [participantData] String field to be used by
   * participant for any intermediate statuses or data they need to save
   */
  constructor() {
  }

  /**
   * Defines the metadata of DataSubjectRightUpdateStatusOperation
   *
   * @returns {object} metadata of DataSubjectRightUpdateStatusOperation
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DataSubjectRightUpdateStatusOperation',
      type: {
        name: 'Composite',
        className: 'DataSubjectRightUpdateStatusOperation',
        modelProperties: {
          requestId: {
            required: true,
            serializedName: 'requestId',
            type: {
              name: 'String'
            }
          },
          status: {
            required: true,
            serializedName: 'status',
            type: {
              name: 'Enum',
              allowedValues: [ 'None', 'Created', 'Queued', 'InProgress', 'Completed', 'Failed' ]
            }
          },
          participantData: {
            required: false,
            serializedName: 'participantData',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = DataSubjectRightUpdateStatusOperation;
