/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a DeviceSetDeviceConfigurationsItem.
 */
class DeviceSetDeviceConfigurationsItem {
  /**
   * Create a DeviceSetDeviceConfigurationsItem.
   * @property {uuid} [id] The unique id of the device configuration
   * @property {object} [image]
   * @property {string} [image.thumb]
   * @property {object} [model]
   * @property {string} [model.name]
   * @property {string} [model.manufacturer]
   * @property {string} [model.releaseDate]
   * @property {string} [model.formFactor]
   * @property {string} [os]
   * @property {string} [osName]
   */
  constructor() {
  }

  /**
   * Defines the metadata of DeviceSetDeviceConfigurationsItem
   *
   * @returns {object} metadata of DeviceSetDeviceConfigurationsItem
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DeviceSet_deviceConfigurationsItem',
      type: {
        name: 'Composite',
        className: 'DeviceSetDeviceConfigurationsItem',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          image: {
            required: false,
            serializedName: 'image',
            type: {
              name: 'Composite',
              className: 'DeviceSetDeviceConfigurationsItemImage'
            }
          },
          model: {
            required: false,
            serializedName: 'model',
            type: {
              name: 'Composite',
              className: 'DeviceSetDeviceConfigurationsItemModel'
            }
          },
          os: {
            required: false,
            serializedName: 'os',
            type: {
              name: 'String'
            }
          },
          osName: {
            required: false,
            serializedName: 'osName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = DeviceSetDeviceConfigurationsItem;
