/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @summary Device Set update information
  *
 * The name of the device set and the list of device IDs
 *
 */
class DeviceSetModelModel {
  /**
   * Create a DeviceSetModelModel.
   * @property {array} devices List of device IDs
   * @property {string} name The name of the device set
   */
  constructor() {
  }

  /**
   * Defines the metadata of DeviceSetModelModel
   *
   * @returns {object} metadata of DeviceSetModelModel
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'deviceSet',
      type: {
        name: 'Composite',
        className: 'DeviceSetModelModel',
        modelProperties: {
          devices: {
            required: true,
            serializedName: 'devices',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = DeviceSetModelModel;
