/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @summary Device Set Owner
  *
 * The owner of a device set
 *
 */
class DeviceSetOwnerModel {
  /**
   * Create a DeviceSetOwnerModel.
   * @property {string} type Type of account
   * @property {string} id Account ID
   * @property {string} [displayName] Display name of the account
   * @property {string} name Name of the account
   */
  constructor() {
  }

  /**
   * Defines the metadata of DeviceSetOwnerModel
   *
   * @returns {object} metadata of DeviceSetOwnerModel
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DeviceSetOwner',
      type: {
        name: 'Composite',
        className: 'DeviceSetOwnerModel',
        modelProperties: {
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          id: {
            required: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          displayName: {
            required: false,
            serializedName: 'displayName',
            type: {
              name: 'String'
            }
          },
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = DeviceSetOwnerModel;
