/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a DistributionGroupAADGroupResponse.
 */
class DistributionGroupAADGroupResponse {
  /**
   * Create a DistributionGroupAADGroupResponse.
   * @property {uuid} [id] The internal unique id (UUID) of the AAD group.
   * @property {uuid} [aadGroupId] The AAD unique id (UUID) of the AAD group.
   * @property {string} [displayName] The display name of the AAD group
   * @property {boolean} [isAadGroup]
   * @property {string} [distributionGroupName] The distribution group of the
   * AAD group
   */
  constructor() {
  }

  /**
   * Defines the metadata of DistributionGroupAADGroupResponse
   *
   * @returns {object} metadata of DistributionGroupAADGroupResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DistributionGroupAADGroupResponse',
      type: {
        name: 'Composite',
        className: 'DistributionGroupAADGroupResponse',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          aadGroupId: {
            required: false,
            serializedName: 'aad_group_id',
            type: {
              name: 'String'
            }
          },
          displayName: {
            required: false,
            serializedName: 'display_name',
            type: {
              name: 'String'
            }
          },
          isAadGroup: {
            required: false,
            serializedName: 'is_aad_group',
            type: {
              name: 'Boolean'
            }
          },
          distributionGroupName: {
            required: false,
            serializedName: 'distribution_group_name',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = DistributionGroupAADGroupResponse;
