/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a DistributionGroupDetailsResponse.
 */
class DistributionGroupDetailsResponse {
  /**
   * Create a DistributionGroupDetailsResponse.
   * @property {uuid} id The unique ID of the distribution group
   * @property {string} name The name of the distribution group used in URLs
   * @property {string} [displayName] The name of the distribution group
   * @property {string} origin The creation origin of this distribution group.
   * Possible values include: 'appcenter', 'hockeyapp'
   * @property {boolean} isPublic Whether the distribution group is public
   * @property {boolean} isShared Whether the distribution group is shared
   * group or not
   * @property {number} totalAppsCount The count of apps associated with this
   * distribution group
   * @property {number} totalUserCount The count of users in the distribution
   * group
   * @property {number} notifiedUserCount The count of non-pending users in the
   * distribution group who will be notified by new releases
   * @property {string} [groupType] Type of group (Default, HockeyAppDefault or
   * MicrosoftDogfooding). Possible values include: 'Default',
   * 'HockeyAppDefault', 'MicrosoftDogfooding'
   * @property {array} users The distribution group users
   */
  constructor() {
  }

  /**
   * Defines the metadata of DistributionGroupDetailsResponse
   *
   * @returns {object} metadata of DistributionGroupDetailsResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DistributionGroupDetailsResponse',
      type: {
        name: 'Composite',
        className: 'DistributionGroupDetailsResponse',
        modelProperties: {
          id: {
            required: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          displayName: {
            required: false,
            serializedName: 'display_name',
            type: {
              name: 'String'
            }
          },
          origin: {
            required: true,
            serializedName: 'origin',
            type: {
              name: 'String'
            }
          },
          isPublic: {
            required: true,
            serializedName: 'is_public',
            type: {
              name: 'Boolean'
            }
          },
          isShared: {
            required: true,
            serializedName: 'is_shared',
            type: {
              name: 'Boolean'
            }
          },
          totalAppsCount: {
            required: true,
            serializedName: 'total_apps_count',
            type: {
              name: 'Number'
            }
          },
          totalUserCount: {
            required: true,
            serializedName: 'total_user_count',
            type: {
              name: 'Number'
            }
          },
          notifiedUserCount: {
            required: true,
            serializedName: 'notified_user_count',
            type: {
              name: 'Number'
            }
          },
          groupType: {
            required: false,
            serializedName: 'group_type',
            type: {
              name: 'String'
            }
          },
          users: {
            required: true,
            serializedName: 'users',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'DistributionGroupDetailsResponseUsersItemElementType',
                  type: {
                    name: 'Composite',
                    className: 'DistributionGroupDetailsResponseUsersItem'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = DistributionGroupDetailsResponse;
