/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a DistributionRequest.
 */
class DistributionRequest {
  /**
   * Create a DistributionRequest.
   * @property {array} [destinations] Array of objects {id:string, type:string}
   * with "id" being the distribution group ID, store ID, or tester email, and
   * "type" being "group", "store", or "tester"
   * @property {string} [releaseNotes] The release notes
   * @property {boolean} [mandatoryUpdate]
   * @property {boolean} [notifyTesters] Default value: true .
   */
  constructor() {
  }

  /**
   * Defines the metadata of DistributionRequest
   *
   * @returns {object} metadata of DistributionRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DistributionRequest',
      type: {
        name: 'Composite',
        className: 'DistributionRequest',
        modelProperties: {
          destinations: {
            required: false,
            serializedName: 'destinations',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'DistributionRequestDestinationsItemElementType',
                  type: {
                    name: 'Composite',
                    className: 'DistributionRequestDestinationsItem'
                  }
              }
            }
          },
          releaseNotes: {
            required: false,
            serializedName: 'releaseNotes',
            type: {
              name: 'String'
            }
          },
          mandatoryUpdate: {
            required: false,
            serializedName: 'mandatoryUpdate',
            type: {
              name: 'Boolean'
            }
          },
          notifyTesters: {
            required: false,
            serializedName: 'notifyTesters',
            defaultValue: true,
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = DistributionRequest;
