/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a EventDeviceCount.
 */
class EventDeviceCount {
  /**
   * Create a EventDeviceCount.
   * @property {number} [totalDevices]
   * @property {number} [totalDevicesWithEvent]
   * @property {number} [previousTotalDevicesWithEvent]
   * @property {array} [devicesCount]
   */
  constructor() {
  }

  /**
   * Defines the metadata of EventDeviceCount
   *
   * @returns {object} metadata of EventDeviceCount
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'EventDeviceCount',
      type: {
        name: 'Composite',
        className: 'EventDeviceCount',
        modelProperties: {
          totalDevices: {
            required: false,
            serializedName: 'total_devices',
            type: {
              name: 'Number'
            }
          },
          totalDevicesWithEvent: {
            required: false,
            serializedName: 'total_devices_with_event',
            type: {
              name: 'Number'
            }
          },
          previousTotalDevicesWithEvent: {
            required: false,
            serializedName: 'previous_total_devices_with_event',
            type: {
              name: 'Number'
            }
          },
          devicesCount: {
            required: false,
            serializedName: 'devices_count',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'EventDeviceCountDevicesCountItemElementType',
                  type: {
                    name: 'Composite',
                    className: 'EventDeviceCountDevicesCountItem'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = EventDeviceCount;
