/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a EventsOKResponse.
 */
class EventsOKResponse {
  /**
   * Create a EventsOKResponse.
   * @property {array} [events]
   * @property {number} [total] The total count of events.
   * @property {number} [totalDevices] The active device over this period.
   */
  constructor() {
  }

  /**
   * Defines the metadata of EventsOKResponse
   *
   * @returns {object} metadata of EventsOKResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'EventsOKResponse',
      type: {
        name: 'Composite',
        className: 'EventsOKResponse',
        modelProperties: {
          events: {
            required: false,
            serializedName: 'events',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'EventsOKResponseEventsItemElementType',
                  type: {
                    name: 'Composite',
                    className: 'EventsOKResponseEventsItem'
                  }
              }
            }
          },
          total: {
            required: false,
            serializedName: 'total',
            type: {
              name: 'Number'
            }
          },
          totalDevices: {
            required: false,
            serializedName: 'total_devices',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = EventsOKResponse;
