/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a EventsOKResponseEventsItem.
 */
class EventsOKResponseEventsItem {
  /**
   * Create a EventsOKResponseEventsItem.
   * @property {string} [id]
   * @property {string} [name]
   * @property {number} [deviceCount]
   * @property {number} [previousDeviceCount] The device count of previous time
   * range of the event.
   * @property {number} [count]
   * @property {number} [previousCount] The event count of previous time range
   * of the event.
   * @property {number} [countPerDevice]
   * @property {number} [countPerSession]
   */
  constructor() {
  }

  /**
   * Defines the metadata of EventsOKResponseEventsItem
   *
   * @returns {object} metadata of EventsOKResponseEventsItem
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'EventsOKResponse_eventsItem',
      type: {
        name: 'Composite',
        className: 'EventsOKResponseEventsItem',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          deviceCount: {
            required: false,
            serializedName: 'device_count',
            type: {
              name: 'Number'
            }
          },
          previousDeviceCount: {
            required: false,
            serializedName: 'previous_device_count',
            type: {
              name: 'Number'
            }
          },
          count: {
            required: false,
            serializedName: 'count',
            type: {
              name: 'Number'
            }
          },
          previousCount: {
            required: false,
            serializedName: 'previous_count',
            type: {
              name: 'Number'
            }
          },
          countPerDevice: {
            required: false,
            serializedName: 'count_per_device',
            type: {
              name: 'Number'
            }
          },
          countPerSession: {
            required: false,
            serializedName: 'count_per_session',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = EventsOKResponseEventsItem;
