/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * A request containing information for creating an externally hosted release.
 *
 */
class ExternallyHostedReleaseCreateRequest {
  /**
   * Create a ExternallyHostedReleaseCreateRequest.
   * @property {string} buildVersion The build version of the uploaded binary
   * @property {string} [buildNumber] The build number of the uploaded binary
   * @property {string} externalDownloadUrl The external URL to the release's
   * binary.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ExternallyHostedReleaseCreateRequest
   *
   * @returns {object} metadata of ExternallyHostedReleaseCreateRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ExternallyHostedReleaseCreateRequest',
      type: {
        name: 'Composite',
        className: 'ExternallyHostedReleaseCreateRequest',
        modelProperties: {
          buildVersion: {
            required: true,
            serializedName: 'build_version',
            type: {
              name: 'String'
            }
          },
          buildNumber: {
            required: false,
            serializedName: 'build_number',
            type: {
              name: 'String'
            }
          },
          externalDownloadUrl: {
            required: true,
            serializedName: 'external_download_url',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ExternallyHostedReleaseCreateRequest;
