/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a FeatureCreateRequest.
 */
class FeatureCreateRequest {
  /**
   * Create a FeatureCreateRequest.
   * @property {string} name The unique name of the feature
   * @property {string} displayName The full (friendly) name of the feature.
   * @property {number} [state] The state of the feature
   * @property {string} [description] The friendly name of the feature
   */
  constructor() {
  }

  /**
   * Defines the metadata of FeatureCreateRequest
   *
   * @returns {object} metadata of FeatureCreateRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'FeatureCreateRequest',
      type: {
        name: 'Composite',
        className: 'FeatureCreateRequest',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          displayName: {
            required: true,
            serializedName: 'display_name',
            type: {
              name: 'String'
            }
          },
          state: {
            required: false,
            serializedName: 'state',
            type: {
              name: 'Number'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = FeatureCreateRequest;
