/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * A request containing a set of release ids to validate
 *
 */
class GDPRValidationRequest {
  /**
   * Create a GDPRValidationRequest.
   * @property {array} releaseIds a list of release ids to validate (AC flow)
   * @property {array} [hockeyappReleaseIds] a list of release ids to validate
   * (HA flow)
   * @property {array} [releaseUploadIds] a list of release uploads ids to
   * validate
   */
  constructor() {
  }

  /**
   * Defines the metadata of GDPRValidationRequest
   *
   * @returns {object} metadata of GDPRValidationRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'GDPRValidationRequest',
      type: {
        name: 'Composite',
        className: 'GDPRValidationRequest',
        modelProperties: {
          releaseIds: {
            required: true,
            serializedName: 'release_ids',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'NumberElementType',
                  type: {
                    name: 'Number'
                  }
              }
            }
          },
          hockeyappReleaseIds: {
            required: false,
            serializedName: 'hockeyapp_release_ids',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'NumberElementType',
                  type: {
                    name: 'Number'
                  }
              }
            }
          },
          releaseUploadIds: {
            required: false,
            serializedName: 'release_upload_ids',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = GDPRValidationRequest;
