/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a GeneralDistributionGroupDetailsResponse.
 */
class GeneralDistributionGroupDetailsResponse {
  /**
   * Create a GeneralDistributionGroupDetailsResponse.
   * @property {uuid} id The unique ID of the distribution group
   * @property {string} name The name of the distribution group used in URLs
   * @property {string} [displayName] The name of the distribution group
   * @property {string} origin The creation origin of this distribution group.
   * Possible values include: 'appcenter', 'hockeyapp'
   * @property {boolean} isPublic Whether the distribution group is public
   * @property {boolean} isShared Whether the distribution group is shared
   * group or not
   * @property {uuid} [ownerAppId] If distribution group is owned by an app,
   * this is the unique app ID
   * @property {uuid} [ownerOrgId] If distribution group is owned by an org,
   * this is the unique org ID
   */
  constructor() {
  }

  /**
   * Defines the metadata of GeneralDistributionGroupDetailsResponse
   *
   * @returns {object} metadata of GeneralDistributionGroupDetailsResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'GeneralDistributionGroupDetailsResponse',
      type: {
        name: 'Composite',
        className: 'GeneralDistributionGroupDetailsResponse',
        modelProperties: {
          id: {
            required: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          displayName: {
            required: false,
            serializedName: 'display_name',
            type: {
              name: 'String'
            }
          },
          origin: {
            required: true,
            serializedName: 'origin',
            type: {
              name: 'String'
            }
          },
          isPublic: {
            required: true,
            serializedName: 'is_public',
            type: {
              name: 'Boolean'
            }
          },
          isShared: {
            required: true,
            serializedName: 'is_shared',
            type: {
              name: 'Boolean'
            }
          },
          ownerAppId: {
            required: false,
            serializedName: 'owner_app_id',
            type: {
              name: 'String'
            }
          },
          ownerOrgId: {
            required: false,
            serializedName: 'owner_org_id',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = GeneralDistributionGroupDetailsResponse;
