/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a GetAppCrashesInfoOKResponse.
 */
class GetAppCrashesInfoOKResponse {
  /**
   * Create a GetAppCrashesInfoOKResponse.
   * @property {boolean} hasCrashes
   * @property {object} features
   * @property {boolean} [features.crashgroupModifyStatus] App supports
   * modification of crashgroup status
   * @property {boolean} [features.crashgroupModifyAnnotation] App supports
   * modification of crashgroup annotation
   * @property {boolean} [features.search] App supports search API
   * @property {boolean} [features.crashgroupAnalyticsCrashfreeusers] App
   * supports the 'crash free user' metric
   * @property {boolean} [features.crashgroupAnalyticsImpactedusers] App
   * supports the 'impacted users' metric
   * @property {boolean} [features.crashDownloadRaw] App supports download of
   * raw crashes
   */
  constructor() {
  }

  /**
   * Defines the metadata of GetAppCrashesInfoOKResponse
   *
   * @returns {object} metadata of GetAppCrashesInfoOKResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'GetAppCrashesInfoOKResponse',
      type: {
        name: 'Composite',
        className: 'GetAppCrashesInfoOKResponse',
        modelProperties: {
          hasCrashes: {
            required: true,
            serializedName: 'has_crashes',
            type: {
              name: 'Boolean'
            }
          },
          features: {
            required: true,
            serializedName: 'features',
            type: {
              name: 'Composite',
              className: 'GetAppCrashesInfoOKResponseFeatures'
            }
          }
        }
      }
    };
  }
}

module.exports = GetAppCrashesInfoOKResponse;
