/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Audience with details.
 *
 */
class GetAudienceOKResponse {
  /**
   * Create a GetAudienceOKResponse.
   * @property {string} [name] Audience name.
   * @property {string} [description] Audience description.
   * @property {number} [estimatedCount] Estimated audience size.
   * @property {string} [definition] Audience definition in OData format.
   * @property {string} [state] Audience state. Possible values include:
   * 'Calculating', 'Ready', 'Disabled'
   * @property {boolean} [enabled] Default value: true .
   * @property {object} [customProperties] Custom properties used in the
   * definition.
   * @property {number} [estimatedTotalCount] Estimated total audience size.
   * @property {date} [timestamp] Date the audience was last refreshed.
   */
  constructor() {
  }

  /**
   * Defines the metadata of GetAudienceOKResponse
   *
   * @returns {object} metadata of GetAudienceOKResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'GetAudienceOKResponse',
      type: {
        name: 'Composite',
        className: 'GetAudienceOKResponse',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          estimatedCount: {
            required: false,
            serializedName: 'estimated_count',
            type: {
              name: 'Number'
            }
          },
          definition: {
            required: false,
            serializedName: 'definition',
            type: {
              name: 'String'
            }
          },
          state: {
            required: false,
            serializedName: 'state',
            type: {
              name: 'Enum',
              allowedValues: [ 'Calculating', 'Ready', 'Disabled' ]
            }
          },
          enabled: {
            required: false,
            serializedName: 'enabled',
            defaultValue: true,
            type: {
              name: 'Boolean'
            }
          },
          customProperties: {
            required: false,
            serializedName: 'custom_properties',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'DevicePropertyTypeElementType',
                  type: {
                    name: 'Enum',
                    allowedValues: [ 'string', 'number', 'boolean', 'date_time' ]
                  }
              }
            }
          },
          estimatedTotalCount: {
            required: false,
            serializedName: 'estimated_total_count',
            type: {
              name: 'Number'
            }
          },
          timestamp: {
            required: false,
            serializedName: 'timestamp',
            type: {
              name: 'DateTime'
            }
          }
        }
      }
    };
  }
}

module.exports = GetAudienceOKResponse;
