/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Selection of a billing plan
 *
 */
class GetForOrgOKResponseBillingPlansBuildServiceCurrentBillingPeriodByAccount {
  /**
   * Create a GetForOrgOKResponseBillingPlansBuildServiceCurrentBillingPeriodByAccount.
   * @property {number} [count] Number of instances of the billing plan.
   * @property {object} [plan] Billing Plan
   * @property {string} [plan.id] The Billing Plan ID
   * @property {string} [plan.version] Version of the Billing Plan schema
   * @property {number} [plan.price] Price of the Billing Plan
   * @property {string} [plan.paymentSource] Service that receives payments for
   * this billing plan. Possible values include: 'None', 'AppCenter', 'GitHub',
   * 'Xtc'
   * @property {string} [plan.service] Name of the service that the plan
   * applies to. Possible values include: 'Build', 'Test'
   * @property {object} [plan.limits] A collection of named numeric values
   * @property {object} [plan.attributes] Collection of attribute values.
   * @property {string} [plan.parentId]
   */
  constructor() {
  }

  /**
   * Defines the metadata of GetForOrgOKResponseBillingPlansBuildServiceCurrentBillingPeriodByAccount
   *
   * @returns {object} metadata of GetForOrgOKResponseBillingPlansBuildServiceCurrentBillingPeriodByAccount
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'GetForOrgOKResponse_billingPlans_buildService_currentBillingPeriod_byAccount',
      type: {
        name: 'Composite',
        className: 'GetForOrgOKResponseBillingPlansBuildServiceCurrentBillingPeriodByAccount',
        modelProperties: {
          count: {
            required: false,
            serializedName: 'count',
            type: {
              name: 'Number'
            }
          },
          plan: {
            required: false,
            serializedName: 'plan',
            type: {
              name: 'Composite',
              className: 'GetForOrgOKResponseBillingPlansBuildServiceCurrentBillingPeriodByAccountPlan'
            }
          }
        }
      }
    };
  }
}

module.exports = GetForOrgOKResponseBillingPlansBuildServiceCurrentBillingPeriodByAccount;
