/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Store details for intune
 *
 */
class GetOKResponseIntuneDetails {
  /**
   * Create a GetOKResponseIntuneDetails.
   * @property {object} [targetAudience]
   * @property {string} [targetAudience.name] display name for the target
   * audience/group
   * @property {string} [targetAudience.id] ID for the target audience/group.
   * @property {object} [appCategory]
   * @property {string} [appCategory.name] display name for the app category
   * @property {string} [appCategory.id] ID for the category.
   */
  constructor() {
  }

  /**
   * Defines the metadata of GetOKResponseIntuneDetails
   *
   * @returns {object} metadata of GetOKResponseIntuneDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'GetOKResponse_intune_details',
      type: {
        name: 'Composite',
        className: 'GetOKResponseIntuneDetails',
        modelProperties: {
          targetAudience: {
            required: false,
            serializedName: 'target_audience',
            type: {
              name: 'Composite',
              className: 'GetOKResponseIntuneDetailsTargetAudience'
            }
          },
          appCategory: {
            required: false,
            serializedName: 'app_category',
            type: {
              name: 'Composite',
              className: 'GetOKResponseIntuneDetailsAppCategory'
            }
          }
        }
      }
    };
  }
}

module.exports = GetOKResponseIntuneDetails;
