/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @summary Test Run Statistics
  *
 * Summary single test run on Xamarin Test Cloud
 *
 */
class GetTestRunOKResponseStats {
  /**
   * Create a GetTestRunOKResponseStats.
   * @property {number} [devices] Number of devices running the test
   * @property {number} [devicesFinished] Number of finished devices
   * @property {number} [devicesFailed] Number of failed devices
   * @property {number} [total] Number of tests in total
   * @property {number} [passed] Number of passed tests
   * @property {number} [failed] Number of failed tests
   * @property {number} [skipped] Number of skipped tests
   * @property {number} [peakMemory] The max amount of MB used during the test
   * run
   * @property {number} [totalDeviceMinutes] The number of minutes of device
   * time the test has been runnign
   */
  constructor() {
  }

  /**
   * Defines the metadata of GetTestRunOKResponseStats
   *
   * @returns {object} metadata of GetTestRunOKResponseStats
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'GetTestRunOKResponse_stats',
      type: {
        name: 'Composite',
        className: 'GetTestRunOKResponseStats',
        modelProperties: {
          devices: {
            required: false,
            serializedName: 'devices',
            type: {
              name: 'Number'
            }
          },
          devicesFinished: {
            required: false,
            serializedName: 'devicesFinished',
            type: {
              name: 'Number'
            }
          },
          devicesFailed: {
            required: false,
            serializedName: 'devicesFailed',
            type: {
              name: 'Number'
            }
          },
          total: {
            required: false,
            serializedName: 'total',
            type: {
              name: 'Number'
            }
          },
          passed: {
            required: false,
            serializedName: 'passed',
            type: {
              name: 'Number'
            }
          },
          failed: {
            required: false,
            serializedName: 'failed',
            type: {
              name: 'Number'
            }
          },
          skipped: {
            required: false,
            serializedName: 'skipped',
            type: {
              name: 'Number'
            }
          },
          peakMemory: {
            required: false,
            serializedName: 'peakMemory',
            type: {
              name: 'Number'
            }
          },
          totalDeviceMinutes: {
            required: false,
            serializedName: 'totalDeviceMinutes',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = GetTestRunOKResponseStats;
