/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a GetUsersOKResponse.
 */
class GetUsersOKResponse {
  /**
   * Create a GetUsersOKResponse.
   * @property {string} email The email address of the user
   * @property {string} displayName The full name of the user. Might for
   * example be first and last name
   * @property {string} name The unique name that is used to identify the user.
   * @property {object} role The role of the user has within the team
   */
  constructor() {
  }

  /**
   * Defines the metadata of GetUsersOKResponse
   *
   * @returns {object} metadata of GetUsersOKResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'GetUsersOKResponse',
      type: {
        name: 'Composite',
        className: 'GetUsersOKResponse',
        modelProperties: {
          email: {
            required: true,
            serializedName: 'email',
            type: {
              name: 'String'
            }
          },
          displayName: {
            required: true,
            serializedName: 'display_name',
            type: {
              name: 'String'
            }
          },
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          role: {
            required: true,
            serializedName: 'role',
            type: {
              name: 'Object'
            }
          }
        }
      }
    };
  }
}

module.exports = GetUsersOKResponse;
