/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * GitHub account information
 *
 */
class GitHubAccount {
  /**
   * Create a GitHubAccount.
   * @property {number} [id] Id of GitHub account
   * @property {string} [accountType] Type of GitHub account. Possible values
   * include: 'User', 'Organization'
   */
  constructor() {
  }

  /**
   * Defines the metadata of GitHubAccount
   *
   * @returns {object} metadata of GitHubAccount
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'GitHubAccount',
      type: {
        name: 'Composite',
        className: 'GitHubAccount',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'Number'
            }
          },
          accountType: {
            required: false,
            serializedName: 'accountType',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = GitHubAccount;
