/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The lite version of GitHub pull request
 *
 */
class GitHubPullRequestLite {
  /**
   * Create a GitHubPullRequestLite.
   * @property {object} [head] The lite version of GitHub branch
   * @property {string} [head.ref] The repository name
   * @property {string} [head.sha] The discription of repository
   * @property {object} [head.repo] The lite version of GitHub repository
   * @property {number} [head.repo.id] The repository id
   * @property {object} [base] The lite version of GitHub branch
   * @property {string} [base.ref] The repository name
   * @property {string} [base.sha] The discription of repository
   * @property {object} [base.repo] The lite version of GitHub repository
   * @property {number} [base.repo.id] The repository id
   */
  constructor() {
  }

  /**
   * Defines the metadata of GitHubPullRequestLite
   *
   * @returns {object} metadata of GitHubPullRequestLite
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'GitHubPullRequestLite',
      type: {
        name: 'Composite',
        className: 'GitHubPullRequestLite',
        modelProperties: {
          head: {
            required: false,
            serializedName: 'head',
            type: {
              name: 'Composite',
              className: 'GitHubPullRequestLiteHead'
            }
          },
          base: {
            required: false,
            serializedName: 'base',
            type: {
              name: 'Composite',
              className: 'GitHubPullRequestLiteBase'
            }
          }
        }
      }
    };
  }
}

module.exports = GitHubPullRequestLite;
