/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a IntuneGroup.
 */
class IntuneGroup {
  /**
   * Create a IntuneGroup.
   * @property {string} [id] the id of the Group
   * @property {string} [displayName] the display name of the group
   * @property {boolean} [securityEnabled] species if it is a security group
   */
  constructor() {
  }

  /**
   * Defines the metadata of IntuneGroup
   *
   * @returns {object} metadata of IntuneGroup
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'IntuneGroup',
      type: {
        name: 'Composite',
        className: 'IntuneGroup',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          displayName: {
            required: false,
            serializedName: 'displayName',
            type: {
              name: 'String'
            }
          },
          securityEnabled: {
            required: false,
            serializedName: 'securityEnabled',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = IntuneGroup;
