/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a IntuneGroups.
 */
class IntuneGroups {
  /**
   * Create a IntuneGroups.
   * @property {string} [odatacontext] context
   * @property {array} [value] categories for intune app
   */
  constructor() {
  }

  /**
   * Defines the metadata of IntuneGroups
   *
   * @returns {object} metadata of IntuneGroups
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'IntuneGroups',
      type: {
        name: 'Composite',
        className: 'IntuneGroups',
        modelProperties: {
          odatacontext: {
            required: false,
            serializedName: 'odata\\.context',
            type: {
              name: 'String'
            }
          },
          value: {
            required: false,
            serializedName: 'value',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'IntuneGroupsValueItemElementType',
                  type: {
                    name: 'Composite',
                    className: 'IntuneGroupsValueItem'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = IntuneGroups;
