/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Apple credentials with username, password or service_connection_id of the
 * stored credentials is needed along with team_identifier.
 *
 */
class ItunesAppsRequest {
  /**
   * Create a ItunesAppsRequest.
   * @property {string} [username] The username for the Apple Developer
   * account.
   * @property {string} [password] The password for the Apple Developer
   * account.
   * @property {string} [serviceConnectionId] The service_connection_id of the
   * stored Apple credentials instead of username, password.
   * @property {string} [teamIdentifier] Identifier of the team to use when
   * logged in.
   * @property {string} [cookie] The 30-day session cookie for multi-factor
   * authentication backed accounts.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ItunesAppsRequest
   *
   * @returns {object} metadata of ItunesAppsRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ItunesAppsRequest',
      type: {
        name: 'Composite',
        className: 'ItunesAppsRequest',
        modelProperties: {
          username: {
            required: false,
            serializedName: 'username',
            type: {
              name: 'String'
            }
          },
          password: {
            required: false,
            serializedName: 'password',
            type: {
              name: 'String'
            }
          },
          serviceConnectionId: {
            required: false,
            serializedName: 'service_connection_id',
            type: {
              name: 'String'
            }
          },
          teamIdentifier: {
            required: false,
            serializedName: 'team_identifier',
            type: {
              name: 'String'
            }
          },
          cookie: {
            required: false,
            serializedName: 'cookie',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ItunesAppsRequest;
