/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Jira credentials non-secret details
 *
 */
class JiraCredentialNonSecretDetailsResponse {
  /**
   * Create a JiraCredentialNonSecretDetailsResponse.
   * @property {string} id id of the shared connection
   * @property {string} [displayName] display name of shared connection
   * @property {string} serviceType service type of shared connection can be
   * apple|gitlab|googleplay|jira. Possible values include: 'apple', 'jira',
   * 'googleplay', 'gitlab'
   * @property {string} credentialType the type of the credential. Possible
   * values include: 'credentials', 'certificate'
   * @property {boolean} [isValid] whether the credentials are valid or not
   * @property {boolean} [is2FA] if the account is a 2FA account or not
   * @property {object} data Jira credentials non-secret details
   * @property {string} [data.baseUrl] baseUrl to connect to jira instance
   * @property {string} [data.username] username to connect to jira instance
   */
  constructor() {
  }

  /**
   * Defines the metadata of JiraCredentialNonSecretDetailsResponse
   *
   * @returns {object} metadata of JiraCredentialNonSecretDetailsResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'credentials',
      type: {
        name: 'Composite',
        className: 'JiraCredentialNonSecretDetailsResponse',
        modelProperties: {
          id: {
            required: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          displayName: {
            required: false,
            serializedName: 'displayName',
            type: {
              name: 'String'
            }
          },
          serviceType: {
            required: true,
            serializedName: 'serviceType',
            type: {
              name: 'String'
            }
          },
          credentialType: {
            required: true,
            serializedName: 'credentialType',
            type: {
              name: 'String'
            }
          },
          isValid: {
            required: false,
            serializedName: 'isValid',
            type: {
              name: 'Boolean'
            }
          },
          is2FA: {
            required: false,
            serializedName: 'is2FA',
            type: {
              name: 'Boolean'
            }
          },
          data: {
            required: true,
            serializedName: 'data',
            type: {
              name: 'Composite',
              className: 'JiraCredentialNonSecretDetailsResponseData'
            }
          }
        }
      }
    };
  }
}

module.exports = JiraCredentialNonSecretDetailsResponse;
