/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a LegacyDeploymentMetric.
 */
class LegacyDeploymentMetric {
  /**
   * Create a LegacyDeploymentMetric.
   * @property {number} active The number of devices that have this release
   * installed currently
   * @property {number} [installed] The number of times this release has been
   * installed on a device
   * @property {number} [downloaded] The number of times this release has been
   * downloaded
   * @property {number} [failed] The number of times this release has failed to
   * be installed on a device
   */
  constructor() {
  }

  /**
   * Defines the metadata of LegacyDeploymentMetric
   *
   * @returns {object} metadata of LegacyDeploymentMetric
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'LegacyDeploymentMetric',
      type: {
        name: 'Composite',
        className: 'LegacyDeploymentMetric',
        modelProperties: {
          active: {
            required: true,
            serializedName: 'active',
            type: {
              name: 'Number'
            }
          },
          installed: {
            required: false,
            serializedName: 'installed',
            type: {
              name: 'Number'
            }
          },
          downloaded: {
            required: false,
            serializedName: 'downloaded',
            type: {
              name: 'Number'
            }
          },
          failed: {
            required: false,
            serializedName: 'failed',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = LegacyDeploymentMetric;
