/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a LinkAADtoUserRequest.
 */
class LinkAADtoUserRequest {
  /**
   * Create a LinkAADtoUserRequest.
   * @property {array} aadTenantIds An array of AAD tenant data needed to link
   * the user to the tenants
   * @property {string} [role] The role of the user to be added. Possible
   * values include: 'admin', 'collaborator', 'member'
   */
  constructor() {
  }

  /**
   * Defines the metadata of LinkAADtoUserRequest
   *
   * @returns {object} metadata of LinkAADtoUserRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'LinkAADtoUserRequest',
      type: {
        name: 'Composite',
        className: 'LinkAADtoUserRequest',
        modelProperties: {
          aadTenantIds: {
            required: true,
            serializedName: 'aad_tenant_ids',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'UuidElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          role: {
            required: false,
            serializedName: 'role',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = LinkAADtoUserRequest;
