/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The branch build status
 *
 */
class ListBranchesOKResponseItem {
  /**
   * Create a ListBranchesOKResponseItem.
   * @property {boolean} configured
   * @property {object} [lastBuild]
   * @property {number} [lastBuild.id] The build ID
   * @property {string} [lastBuild.buildNumber] The build number
   * @property {string} [lastBuild.queueTime] The time the build was queued
   * @property {string} [lastBuild.startTime] The time the build was started
   * @property {string} [lastBuild.finishTime] The time the build was finished
   * @property {string} [lastBuild.lastChangedDate] The time the build status
   * was last changed
   * @property {string} [lastBuild.status] The build status
   * @property {string} [lastBuild.result] The build result
   * @property {string} [lastBuild.sourceBranch] The source branch name
   * @property {string} [lastBuild.sourceVersion] The source SHA
   */
  constructor() {
  }

  /**
   * Defines the metadata of ListBranchesOKResponseItem
   *
   * @returns {object} metadata of ListBranchesOKResponseItem
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ListBranchesOKResponseItem',
      type: {
        name: 'Composite',
        additionalProperties: {
          type: {
            name: 'Dictionary',
            value: {
                required: false,
                serializedName: 'ListBranchesOKResponseItemValueElementType',
                type: {
                  name: 'Composite',
                  className: 'ListBranchesOKResponseItemValue'
                }
            }
          }
        },
        className: 'ListBranchesOKResponseItem',
        modelProperties: {
          configured: {
            required: true,
            serializedName: 'configured',
            type: {
              name: 'Boolean'
            }
          },
          lastBuild: {
            required: false,
            serializedName: 'lastBuild',
            type: {
              name: 'Composite',
              className: 'ListBranchesOKResponseItemLastBuild'
            }
          }
        }
      }
    };
  }
}

module.exports = ListBranchesOKResponseItem;
