/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a ListForOrgCreatedResponseItem.
 */
class ListForOrgCreatedResponseItem {
  /**
   * Create a ListForOrgCreatedResponseItem.
   * @property {uuid} id The unique ID of the distribution group
   * @property {string} name The name of the distribution group used in URLs
   * @property {string} [displayName] The name of the distribution group
   * @property {string} origin The creation origin of this distribution group.
   * Possible values include: 'appcenter', 'hockeyapp'
   * @property {boolean} isPublic Whether the distribution group is public
   */
  constructor() {
  }

  /**
   * Defines the metadata of ListForOrgCreatedResponseItem
   *
   * @returns {object} metadata of ListForOrgCreatedResponseItem
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ListForOrgCreatedResponseItem',
      type: {
        name: 'Composite',
        className: 'ListForOrgCreatedResponseItem',
        modelProperties: {
          id: {
            required: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          displayName: {
            required: false,
            serializedName: 'display_name',
            type: {
              name: 'String'
            }
          },
          origin: {
            required: true,
            serializedName: 'origin',
            type: {
              name: 'String'
            }
          },
          isPublic: {
            required: true,
            serializedName: 'is_public',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = ListForOrgCreatedResponseItem;
