/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a ListOKResponseCrashGroupsItem.
 */
class ListOKResponseCrashGroupsItem {
  /**
   * Create a ListOKResponseCrashGroupsItem.
   * @property {string} crashGroupId
   * @property {string} newCrashGroupId
   * @property {string} displayId
   * @property {string} appVersion
   * @property {string} build
   * @property {string} status Possible values include: 'open', 'closed',
   * 'ignored'
   * @property {number} count
   * @property {number} [impactedUsers]
   * @property {date} firstOccurrence
   * @property {date} lastOccurrence
   * @property {string} [exception]
   * @property {string} crashReason
   * @property {object} [reasonFrame] frame belonging to the reason of the
   * crash
   * @property {string} [reasonFrame.className] name of the class
   * @property {string} [reasonFrame.method] name of the method
   * @property {boolean} [reasonFrame.classMethod] is a class method
   * @property {string} [reasonFrame.file] name of the file
   * @property {number} [reasonFrame.line] line number
   * @property {boolean} [reasonFrame.appCode] this line isn't from any
   * framework
   * @property {string} [reasonFrame.frameworkName] Name of the framework
   * @property {string} [reasonFrame.codeFormatted] Formatted frame string
   * @property {string} [reasonFrame.codeRaw] Unformatted Frame string
   * @property {string} [reasonFrame.language] programming language of the
   * frame. Possible values include: 'JavaScript', 'CSharp', 'Objective-C',
   * 'Objective-Cpp', 'Cpp', 'C', 'Swift', 'Java', 'Unknown'
   * @property {string} [reasonFrame.methodParams] parameters of the frames
   * method
   * @property {string} [reasonFrame.exceptionType] Exception type.
   * @property {string} [reasonFrame.osExceptionType] OS exception type. (aka.
   * SIGNAL)
   * @property {boolean} fatal Crash or handled exception
   * @property {string} annotation
   */
  constructor() {
  }

  /**
   * Defines the metadata of ListOKResponseCrashGroupsItem
   *
   * @returns {object} metadata of ListOKResponseCrashGroupsItem
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ListOKResponse_crash_groupsItem',
      type: {
        name: 'Composite',
        className: 'ListOKResponseCrashGroupsItem',
        modelProperties: {
          crashGroupId: {
            required: true,
            serializedName: 'crash_group_id',
            type: {
              name: 'String'
            }
          },
          newCrashGroupId: {
            required: true,
            serializedName: 'new_crash_group_id',
            type: {
              name: 'String'
            }
          },
          displayId: {
            required: true,
            serializedName: 'display_id',
            type: {
              name: 'String'
            }
          },
          appVersion: {
            required: true,
            serializedName: 'app_version',
            type: {
              name: 'String'
            }
          },
          build: {
            required: true,
            serializedName: 'build',
            type: {
              name: 'String'
            }
          },
          status: {
            required: true,
            serializedName: 'status',
            type: {
              name: 'String'
            }
          },
          count: {
            required: true,
            serializedName: 'count',
            type: {
              name: 'Number'
            }
          },
          impactedUsers: {
            required: false,
            serializedName: 'impacted_users',
            type: {
              name: 'Number'
            }
          },
          firstOccurrence: {
            required: true,
            serializedName: 'first_occurrence',
            type: {
              name: 'DateTime'
            }
          },
          lastOccurrence: {
            required: true,
            serializedName: 'last_occurrence',
            type: {
              name: 'DateTime'
            }
          },
          exception: {
            required: false,
            serializedName: 'exception',
            type: {
              name: 'String'
            }
          },
          crashReason: {
            required: true,
            serializedName: 'crash_reason',
            type: {
              name: 'String'
            }
          },
          reasonFrame: {
            required: false,
            serializedName: 'reason_frame',
            type: {
              name: 'Composite',
              className: 'ListOKResponseCrashGroupsItemReasonFrame'
            }
          },
          fatal: {
            required: true,
            serializedName: 'fatal',
            type: {
              name: 'Boolean'
            }
          },
          annotation: {
            required: true,
            serializedName: 'annotation',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ListOKResponseCrashGroupsItem;
