/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a ListOKResponseItemDistributionStoresItemModel.
 */
class ListOKResponseItemDistributionStoresItemModel {
  /**
   * Create a ListOKResponseItemDistributionStoresItemModel.
   * @property {string} [id] ID identifying a unique distribution store.
   * @property {string} [name] A name identifying a unique distribution store.
   * @property {string} [type] A type identifying the type of distribution
   * store. Possible values include: 'googleplay', 'intune', 'apple'
   * @property {string} [publishingStatus] A status identifying the status of
   * release in the distribution store.
   * @property {boolean} [isLatest] Is the containing release the latest one in
   * this distribution store.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ListOKResponseItemDistributionStoresItemModel
   *
   * @returns {object} metadata of ListOKResponseItemDistributionStoresItemModel
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ListOKResponseItem_distribution_storesItem',
      type: {
        name: 'Composite',
        className: 'ListOKResponseItemDistributionStoresItemModel',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          publishingStatus: {
            required: false,
            serializedName: 'publishing_status',
            type: {
              name: 'String'
            }
          },
          isLatest: {
            required: false,
            serializedName: 'is_latest',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = ListOKResponseItemDistributionStoresItemModel;
