/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Set of toolsets available for app
 *
 */
class ListToolsetsOKResponse {
  /**
   * Create a ListToolsetsOKResponse.
   * @property {array} [xamarin] A list of Xamarin SDK bundles
   * @property {array} [xcode] A list of Xcode versions
   * @property {array} [node] A list of Node versions
   */
  constructor() {
  }

  /**
   * Defines the metadata of ListToolsetsOKResponse
   *
   * @returns {object} metadata of ListToolsetsOKResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ListToolsetsOKResponse',
      type: {
        name: 'Composite',
        className: 'ListToolsetsOKResponse',
        modelProperties: {
          xamarin: {
            required: false,
            serializedName: 'xamarin',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ListToolsetsOKResponseXamarinItemElementType',
                  type: {
                    name: 'Composite',
                    className: 'ListToolsetsOKResponseXamarinItem'
                  }
              }
            }
          },
          xcode: {
            required: false,
            serializedName: 'xcode',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ListToolsetsOKResponseXcodeItemElementType',
                  type: {
                    name: 'Composite',
                    className: 'ListToolsetsOKResponseXcodeItem'
                  }
              }
            }
          },
          node: {
            required: false,
            serializedName: 'node',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ListToolsetsOKResponseNodeItemElementType',
                  type: {
                    name: 'Composite',
                    className: 'ListToolsetsOKResponseNodeItem'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ListToolsetsOKResponse;
