/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a ListUsersOKResponseItem.
 */
class ListUsersOKResponseItem {
  /**
   * Create a ListUsersOKResponseItem.
   * @property {uuid} [id] The unique id (UUID) of the user
   * @property {string} [avatarUrl] The avatar URL of the user
   * @property {boolean} [canChangePassword] User is required to send an old
   * password in order to change the password.
   * @property {string} [displayName] The full name of the user. Might for
   * example be first and last name
   * @property {string} email The email address of the user
   * @property {boolean} [invitePending] Whether the has accepted the invite.
   * Available when an invite is pending, and the value will be "true".
   * @property {string} [name] The unique name that is used to identify the
   * user.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ListUsersOKResponseItem
   *
   * @returns {object} metadata of ListUsersOKResponseItem
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ListUsersOKResponseItem',
      type: {
        name: 'Composite',
        className: 'ListUsersOKResponseItem',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          avatarUrl: {
            required: false,
            serializedName: 'avatar_url',
            type: {
              name: 'String'
            }
          },
          canChangePassword: {
            required: false,
            serializedName: 'can_change_password',
            type: {
              name: 'Boolean'
            }
          },
          displayName: {
            required: false,
            serializedName: 'display_name',
            type: {
              name: 'String'
            }
          },
          email: {
            required: true,
            serializedName: 'email',
            type: {
              name: 'String'
            }
          },
          invitePending: {
            required: false,
            serializedName: 'invite_pending',
            type: {
              name: 'Boolean'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ListUsersOKResponseItem;
