/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Envelope for messages sent to actors
 *
 */
class MessageEnvelope {
  /**
   * Create a MessageEnvelope.
   * @property {string} [messageId] Unique id of the message
   * @property {string} [messageType] Type of the message
   * @property {object} [message] Body of the message
   */
  constructor() {
  }

  /**
   * Defines the metadata of MessageEnvelope
   *
   * @returns {object} metadata of MessageEnvelope
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'MessageEnvelope',
      type: {
        name: 'Composite',
        className: 'MessageEnvelope',
        modelProperties: {
          messageId: {
            required: false,
            serializedName: 'messageId',
            type: {
              name: 'String'
            }
          },
          messageType: {
            required: false,
            serializedName: 'messageType',
            type: {
              name: 'String'
            }
          },
          message: {
            required: false,
            serializedName: 'message',
            type: {
              name: 'Object'
            }
          }
        }
      }
    };
  }
}

module.exports = MessageEnvelope;
