/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * New crash group alerting event
 *
 */
class NewCrashGroupAlertingEvent {
  /**
   * Create a NewCrashGroupAlertingEvent.
   * @property {string} eventTimestamp ISO 8601 date time when event was
   * generated
   * @property {string} eventId A unique identifier for this event instance.
   * Useful for deduplication
   * @property {object} [properties] Obsolete. Use emailProperties.
   * @property {object} [crashGroupProperties] Properties of new crash group
   * @property {string} [crashGroupProperties.id]
   * @property {string} [crashGroupProperties.name]
   * @property {string} [crashGroupProperties.reason]
   * @property {string} [crashGroupProperties.url]
   * @property {string} [crashGroupProperties.appDisplayName]
   * @property {string} [crashGroupProperties.appPlatform]
   * @property {string} [crashGroupProperties.appVersion]
   * @property {array} [crashGroupProperties.stackTrace]
   */
  constructor() {
  }

  /**
   * Defines the metadata of NewCrashGroupAlertingEvent
   *
   * @returns {object} metadata of NewCrashGroupAlertingEvent
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'NewCrashGroupAlertingEvent',
      type: {
        name: 'Composite',
        className: 'NewCrashGroupAlertingEvent',
        modelProperties: {
          eventTimestamp: {
            required: true,
            serializedName: 'event_timestamp',
            type: {
              name: 'String'
            }
          },
          eventId: {
            required: true,
            serializedName: 'event_id',
            type: {
              name: 'String'
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Object'
            }
          },
          crashGroupProperties: {
            required: false,
            serializedName: 'crash_group_properties',
            type: {
              name: 'Composite',
              className: 'NewCrashGroupAlertingEventCrashGroupProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = NewCrashGroupAlertingEvent;
