/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a NewCreatedResponse.
 */
class NewCreatedResponse {
  /**
   * Create a NewCreatedResponse.
   * @property {string} id The unique id (UUID) of the api token
   * @property {string} apiToken The api token generated will not be accessible
   * again
   * @property {string} [description] The description of the token
   * @property {array} [scope] The scope for this token.
   * @property {string} createdAt The creation time
   */
  constructor() {
  }

  /**
   * Defines the metadata of NewCreatedResponse
   *
   * @returns {object} metadata of NewCreatedResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'NewCreatedResponse',
      type: {
        name: 'Composite',
        className: 'NewCreatedResponse',
        modelProperties: {
          id: {
            required: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          apiToken: {
            required: true,
            serializedName: 'api_token',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          scope: {
            required: false,
            serializedName: 'scope',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          createdAt: {
            required: true,
            serializedName: 'created_at',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = NewCreatedResponse;
