/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Google notification configuration. The 'type' property must be set to
 * 'gcm_config'
 *
 */
class NotificationConfigGoogle {
  /**
   * Create a NotificationConfigGoogle.
   * @property {string} type Possible values include: 'apns_token_config',
   * 'gcm_config', 'wns_config'
   * @property {string} googleApiKey GCM API key.
   */
  constructor() {
  }

  /**
   * Defines the metadata of NotificationConfigGoogle
   *
   * @returns {object} metadata of NotificationConfigGoogle
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'gcm_config',
      type: {
        name: 'Composite',
        className: 'NotificationConfigGoogle',
        modelProperties: {
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          googleApiKey: {
            required: true,
            serializedName: 'google_api_key',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = NotificationConfigGoogle;
