/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * WNS notification configuration. The 'type' property must be set to
 * 'wns_config'
 *
 */
class NotificationConfigWindows {
  /**
   * Create a NotificationConfigWindows.
   * @property {string} type Possible values include: 'apns_token_config',
   * 'gcm_config', 'wns_config'
   * @property {string} packageSid Package security identifier (SID).
   * @property {string} secretKey Secret key.
   */
  constructor() {
  }

  /**
   * Defines the metadata of NotificationConfigWindows
   *
   * @returns {object} metadata of NotificationConfigWindows
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'wns_config',
      type: {
        name: 'Composite',
        className: 'NotificationConfigWindows',
        modelProperties: {
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          packageSid: {
            required: true,
            serializedName: 'package_sid',
            type: {
              name: 'String'
            }
          },
          secretKey: {
            required: true,
            serializedName: 'secret_key',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = NotificationConfigWindows;
