/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Notification per Account IDs
 *
 */
class NotificationTargetAccountIds {
  /**
   * Create a NotificationTargetAccountIds.
   * @property {string} type Possible values include: 'audiences_target',
   * 'devices_target', 'user_ids_target', 'account_ids_target',
   * 'broadcast_target'
   * @property {array} accountIds List of account IDs to target
   */
  constructor() {
  }

  /**
   * Defines the metadata of NotificationTargetAccountIds
   *
   * @returns {object} metadata of NotificationTargetAccountIds
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'account_ids_target',
      type: {
        name: 'Composite',
        className: 'NotificationTargetAccountIds',
        modelProperties: {
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          accountIds: {
            required: true,
            serializedName: 'account_ids',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = NotificationTargetAccountIds;
