/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a OrgDistributionGroupDetailsResponse.
 */
class OrgDistributionGroupDetailsResponse {
  /**
   * Create a OrgDistributionGroupDetailsResponse.
   * @property {uuid} id The unique ID of the distribution group
   * @property {string} name The name of the distribution group used in URLs
   * @property {string} [displayName] The name of the distribution group
   * @property {string} origin The creation origin of this distribution group.
   * Possible values include: 'appcenter', 'hockeyapp'
   * @property {boolean} isPublic Whether the distribution group is public
   * @property {number} totalAppsCount The count of apps associated with this
   * distribution group
   * @property {number} totalUsersCount The count of users in the distribution
   * group
   * @property {array} apps The apps associated with the distribution group
   */
  constructor() {
  }

  /**
   * Defines the metadata of OrgDistributionGroupDetailsResponse
   *
   * @returns {object} metadata of OrgDistributionGroupDetailsResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'OrgDistributionGroupDetailsResponse',
      type: {
        name: 'Composite',
        className: 'OrgDistributionGroupDetailsResponse',
        modelProperties: {
          id: {
            required: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          displayName: {
            required: false,
            serializedName: 'display_name',
            type: {
              name: 'String'
            }
          },
          origin: {
            required: true,
            serializedName: 'origin',
            type: {
              name: 'String'
            }
          },
          isPublic: {
            required: true,
            serializedName: 'is_public',
            type: {
              name: 'Boolean'
            }
          },
          totalAppsCount: {
            required: true,
            serializedName: 'total_apps_count',
            type: {
              name: 'Number'
            }
          },
          totalUsersCount: {
            required: true,
            serializedName: 'total_users_count',
            type: {
              name: 'Number'
            }
          },
          apps: {
            required: true,
            serializedName: 'apps',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'OrgDistributionGroupDetailsResponseAppsItemElementType',
                  type: {
                    name: 'Composite',
                    className: 'OrgDistributionGroupDetailsResponseAppsItem'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = OrgDistributionGroupDetailsResponse;
