/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a OrganizationInvitationDetailResponse.
 */
class OrganizationInvitationDetailResponse {
  /**
   * Create a OrganizationInvitationDetailResponse.
   * @property {uuid} id The unique ID (UUID) of the invitation
   * @property {object} organization
   * @property {uuid} [organization.id] The internal unique id (UUID) of the
   * organization.
   * @property {string} [organization.displayName] The display name of the
   * organization
   * @property {string} [organization.name] The slug name of the organization
   * @property {string} [organization.avatarUrl] The URL to a user-uploaded
   * Avatar image
   * @property {string} [organization.origin] The creation origin of this
   * organization. Possible values include: 'appcenter', 'hockeyapp'
   * @property {string} [organization.createdAt] The creation date of this
   * organization
   * @property {string} [organization.updatedAt] The date the organization was
   * last updated at
   * @property {string} email The email address of the invited user
   * @property {object} invitedBy
   * @property {uuid} [invitedBy.id] The unique id (UUID) of the user
   * @property {string} [invitedBy.avatarUrl] The avatar URL of the user
   * @property {boolean} [invitedBy.canChangePassword] User is required to send
   * an old password in order to change the password.
   * @property {string} [invitedBy.displayName] The full name of the user.
   * Might for example be first and last name
   * @property {string} [invitedBy.email] The email address of the user
   * @property {string} [invitedBy.name] The unique name that is used to
   * identify the user.
   * @property {array} [invitedBy.permissions] The permissions the user has for
   * the app
   * @property {string} [invitedBy.origin] The creation origin of this user.
   * Possible values include: 'appcenter', 'hockeyapp', 'codepush'
   * @property {boolean} isExistingUser Indicates whether the invited user
   * already exists
   * @property {string} [role] The role assigned to the invited user
   */
  constructor() {
  }

  /**
   * Defines the metadata of OrganizationInvitationDetailResponse
   *
   * @returns {object} metadata of OrganizationInvitationDetailResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'OrganizationInvitationDetailResponse',
      type: {
        name: 'Composite',
        className: 'OrganizationInvitationDetailResponse',
        modelProperties: {
          id: {
            required: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          organization: {
            required: true,
            serializedName: 'organization',
            type: {
              name: 'Composite',
              className: 'OrganizationInvitationDetailResponseOrganization'
            }
          },
          email: {
            required: true,
            serializedName: 'email',
            type: {
              name: 'String'
            }
          },
          invitedBy: {
            required: true,
            serializedName: 'invited_by',
            type: {
              name: 'Composite',
              className: 'OrganizationInvitationDetailResponseInvitedBy'
            }
          },
          isExistingUser: {
            required: true,
            serializedName: 'is_existing_user',
            type: {
              name: 'Boolean'
            }
          },
          role: {
            required: false,
            serializedName: 'role',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = OrganizationInvitationDetailResponse;
