/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a OrganizationRequest.
 */
class OrganizationRequest {
  /**
   * Create a OrganizationRequest.
   * @property {string} [displayName] The display name of the organization
   * @property {string} [name] The name of the organization used in URLs
   */
  constructor() {
  }

  /**
   * Defines the metadata of OrganizationRequest
   *
   * @returns {object} metadata of OrganizationRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'OrganizationRequest',
      type: {
        name: 'Composite',
        className: 'OrganizationRequest',
        modelProperties: {
          displayName: {
            required: false,
            serializedName: 'display_name',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = OrganizationRequest;
