/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Patch the asset id of a release request body
 *
 */
class PatchReleaseAssetIdRequest {
  /**
   * Create a PatchReleaseAssetIdRequest.
   * @property {uuid} packageAssetId The release new package id in ACFUS
   * @property {uuid} uploadId The release upload id used to upload the release
   * @property {string} [ipaUuids] The ipa UUIDs for this release, as a
   * serialized JSON array
   */
  constructor() {
  }

  /**
   * Defines the metadata of PatchReleaseAssetIdRequest
   *
   * @returns {object} metadata of PatchReleaseAssetIdRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PatchReleaseAssetIdRequest',
      type: {
        name: 'Composite',
        className: 'PatchReleaseAssetIdRequest',
        modelProperties: {
          packageAssetId: {
            required: true,
            serializedName: 'package_asset_id',
            type: {
              name: 'String'
            }
          },
          uploadId: {
            required: true,
            serializedName: 'upload_id',
            type: {
              name: 'String'
            }
          },
          ipaUuids: {
            required: false,
            serializedName: 'ipa_uuids',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = PatchReleaseAssetIdRequest;
