/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a PatchReleaseRequest.
 */
class PatchReleaseRequest {
  /**
   * Create a PatchReleaseRequest.
   * @property {string} [status] updated status of release
   * @property {string} [destPublishId] Destination Publish Id
   * @property {string} [errorDetails] failure error details from store
   * @property {string} [errorContextId] contextId for failed error message
   * @property {string} [wrapPackageUrl] package url for wrapping request
   * @property {boolean} [isWrapperRequest] request is for wrapping or not
   */
  constructor() {
  }

  /**
   * Defines the metadata of PatchReleaseRequest
   *
   * @returns {object} metadata of PatchReleaseRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PatchReleaseRequest',
      type: {
        name: 'Composite',
        className: 'PatchReleaseRequest',
        modelProperties: {
          status: {
            required: false,
            serializedName: 'status',
            type: {
              name: 'String'
            }
          },
          destPublishId: {
            required: false,
            serializedName: 'dest_publish_id',
            type: {
              name: 'String'
            }
          },
          errorDetails: {
            required: false,
            serializedName: 'error_details',
            type: {
              name: 'String'
            }
          },
          errorContextId: {
            required: false,
            serializedName: 'error_contextId',
            type: {
              name: 'String'
            }
          },
          wrapPackageUrl: {
            required: false,
            serializedName: 'wrap_package_url',
            type: {
              name: 'String'
            }
          },
          isWrapperRequest: {
            required: false,
            serializedName: 'is_wrapper_request',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = PatchReleaseRequest;
