/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @summary Performance Report
  *
 * Report data for a single test (a.k.a. scenario)
 *
 */
class PerformanceReport {
  /**
   * Create a PerformanceReport.
   * @property {string} [deviceSnapshotId]
   * @property {object} [performanceData]
   * @property {array} [performanceData.steps]
   * @property {number} [performanceData.elapsedSecsEnd]
   * @property {number} [performanceData.elapsedSecsStart]
   * @property {number} [performanceData.elapsedSecs]
   * @property {string} [performanceData.id]
   * @property {object} [video]
   * @property {object} [video.videoMetadata]
   * @property {array} [video.videoMetadata.events]
   * @property {string} [video.videoUrl]
   */
  constructor() {
  }

  /**
   * Defines the metadata of PerformanceReport
   *
   * @returns {object} metadata of PerformanceReport
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PerformanceReport',
      type: {
        name: 'Composite',
        className: 'PerformanceReport',
        modelProperties: {
          deviceSnapshotId: {
            required: false,
            serializedName: 'device_snapshot_id',
            type: {
              name: 'String'
            }
          },
          performanceData: {
            required: false,
            serializedName: 'performance_data',
            type: {
              name: 'Composite',
              className: 'PerformanceReportPerformanceData'
            }
          },
          video: {
            required: false,
            serializedName: 'video',
            type: {
              name: 'Composite',
              className: 'PerformanceReportVideo'
            }
          }
        }
      }
    };
  }
}

module.exports = PerformanceReport;
