/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a PerformanceReportPerformanceDataStepsItem.
 */
class PerformanceReportPerformanceDataStepsItem {
  /**
   * Create a PerformanceReportPerformanceDataStepsItem.
   * @property {number} [avgCpu]
   * @property {number} [avgMem]
   * @property {array} [samples]
   * @property {number} [elapsedSecsEnd]
   * @property {number} [elapsedSecsStart]
   * @property {number} [elapsedSecs]
   * @property {string} [name]
   * @property {string} [id]
   */
  constructor() {
  }

  /**
   * Defines the metadata of PerformanceReportPerformanceDataStepsItem
   *
   * @returns {object} metadata of PerformanceReportPerformanceDataStepsItem
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PerformanceReport_performance_data_stepsItem',
      type: {
        name: 'Composite',
        className: 'PerformanceReportPerformanceDataStepsItem',
        modelProperties: {
          avgCpu: {
            required: false,
            serializedName: 'avg-cpu',
            type: {
              name: 'Number'
            }
          },
          avgMem: {
            required: false,
            serializedName: 'avg-mem',
            type: {
              name: 'Number'
            }
          },
          samples: {
            required: false,
            serializedName: 'samples',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'PerformanceReportPerformanceDataStepsItemSamplesItemElementType',
                  type: {
                    name: 'Composite',
                    className: 'PerformanceReportPerformanceDataStepsItemSamplesItem'
                  }
              }
            }
          },
          elapsedSecsEnd: {
            required: false,
            serializedName: 'elapsed-secs-end',
            type: {
              name: 'Number'
            }
          },
          elapsedSecsStart: {
            required: false,
            serializedName: 'elapsed-secs-start',
            type: {
              name: 'Number'
            }
          },
          elapsedSecs: {
            required: false,
            serializedName: 'elapsed-secs',
            type: {
              name: 'Number'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = PerformanceReportPerformanceDataStepsItem;
