/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * private Apple connection secrets response
 *
 */
class PrivateAppleCertificateSecretResponse {
  /**
   * Create a PrivateAppleCertificateSecretResponse.
   * @property {string} id id of the shared connection
   * @property {string} [displayName] display name of shared connection
   * @property {string} serviceType service type of shared connection can be
   * apple|gitlab|googleplay|jira|applecertificate. Possible values include:
   * 'apple', 'jira', 'googleplay', 'gitlab'
   * @property {boolean} [isValid] whether the credentials are valid or not
   * @property {boolean} [is2FA] if the account is a 2FA account or not
   * @property {object} data apple secret details
   * @property {string} [data.base64Certificate] The certificate contents in
   * base 64 encoded string
   * @property {string} [data.password] The password for the certificate
   * @property {string} [data.displayName] The display name (CN) of the
   * certificate
   * @property {string} [data.certificateValidityStartDate] The date-time from
   * which the certificate is valid
   * @property {string} [data.certificateValidityEndDate] The date-time till
   * which the certificate is valid
   */
  constructor() {
  }

  /**
   * Defines the metadata of PrivateAppleCertificateSecretResponse
   *
   * @returns {object} metadata of PrivateAppleCertificateSecretResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'certificate',
      type: {
        name: 'Composite',
        className: 'PrivateAppleCertificateSecretResponse',
        modelProperties: {
          id: {
            required: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          displayName: {
            required: false,
            serializedName: 'displayName',
            type: {
              name: 'String'
            }
          },
          serviceType: {
            required: true,
            serializedName: 'serviceType',
            type: {
              name: 'String'
            }
          },
          isValid: {
            required: false,
            serializedName: 'isValid',
            type: {
              name: 'Boolean'
            }
          },
          is2FA: {
            required: false,
            serializedName: 'is2FA',
            type: {
              name: 'Boolean'
            }
          },
          data: {
            required: true,
            serializedName: 'data',
            type: {
              name: 'Composite',
              className: 'PrivateAppleCertificateSecretResponseData'
            }
          }
        }
      }
    };
  }
}

module.exports = PrivateAppleCertificateSecretResponse;
