/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a PrivateIntuneStoreRequest.
 */
class PrivateIntuneStoreRequest {
  /**
   * Create a PrivateIntuneStoreRequest.
   * @property {object} [targetAudience]
   * @property {string} [targetAudience.name] display name for the target
   * audience/group
   * @property {object} [appCategory]
   * @property {string} [appCategory.name] display name for the app category
   * @property {string} [tenantId] tenant id of the intune store
   */
  constructor() {
  }

  /**
   * Defines the metadata of PrivateIntuneStoreRequest
   *
   * @returns {object} metadata of PrivateIntuneStoreRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PrivateIntuneStoreRequest',
      type: {
        name: 'Composite',
        className: 'PrivateIntuneStoreRequest',
        modelProperties: {
          targetAudience: {
            required: false,
            serializedName: 'target_audience',
            type: {
              name: 'Composite',
              className: 'PrivateIntuneStoreRequestTargetAudience'
            }
          },
          appCategory: {
            required: false,
            serializedName: 'app_category',
            type: {
              name: 'Composite',
              className: 'PrivateIntuneStoreRequestAppCategory'
            }
          },
          tenantId: {
            required: false,
            serializedName: 'tenant_id',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = PrivateIntuneStoreRequest;
