/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * An object containing information about an iOS provisioning profile.
 *
 */
class ReleaseCreateRequestAppexProvisioningProfilesItem {
  /**
   * Create a ReleaseCreateRequestAppexProvisioningProfilesItem.
   * @property {string} name The name of the provisioning profile.
   * @property {string} applicationIdentifier The application identifier.
   * @property {string} teamIdentifier The team identifier.
   * @property {string} profileType Possible values include: 'adhoc',
   * 'enterprise', 'other'
   * @property {date} expiredAt The profile's expiration date in RFC 3339
   * format, i.e. 2017-07-21T17:32:28Z
   * @property {array} [udids]
   */
  constructor() {
  }

  /**
   * Defines the metadata of ReleaseCreateRequestAppexProvisioningProfilesItem
   *
   * @returns {object} metadata of ReleaseCreateRequestAppexProvisioningProfilesItem
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ReleaseCreateRequest_appex_provisioning_profilesItem',
      type: {
        name: 'Composite',
        className: 'ReleaseCreateRequestAppexProvisioningProfilesItem',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          applicationIdentifier: {
            required: true,
            serializedName: 'application_identifier',
            type: {
              name: 'String'
            }
          },
          teamIdentifier: {
            required: true,
            serializedName: 'team_identifier',
            type: {
              name: 'String'
            }
          },
          profileType: {
            required: true,
            serializedName: 'profile_type',
            type: {
              name: 'String'
            }
          },
          expiredAt: {
            required: true,
            serializedName: 'expired_at',
            type: {
              name: 'DateTime'
            }
          },
          udids: {
            required: false,
            serializedName: 'udids',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ReleaseCreateRequestAppexProvisioningProfilesItem;
