/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a ReleaseDestinationResponse.
 */
class ReleaseDestinationResponse {
  /**
   * Create a ReleaseDestinationResponse.
   * @property {string} id Unique id for the release destination
   * @property {boolean} mandatoryUpdate Flag to mark the release for the
   * provided destinations as mandatory
   * @property {string} [provisioningStatusUrl] The url to check provisioning
   * status.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ReleaseDestinationResponse
   *
   * @returns {object} metadata of ReleaseDestinationResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ReleaseDestinationResponse',
      type: {
        name: 'Composite',
        className: 'ReleaseDestinationResponse',
        modelProperties: {
          id: {
            required: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          mandatoryUpdate: {
            required: true,
            serializedName: 'mandatory_update',
            type: {
              name: 'Boolean'
            }
          },
          provisioningStatusUrl: {
            required: false,
            serializedName: 'provisioning_status_url',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ReleaseDestinationResponse;
