/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a ReleaseMetadataModel.
 */
class ReleaseMetadataModel {
  /**
   * Create a ReleaseMetadataModel.
   * @property {string} [deploymentKey]
   * @property {string} [label]
   * @property {string} [appVersion]
   * @property {string} [previousDeploymentKey]
   * @property {string} [previousLabelOrAppVersion]
   * @property {string} [status]
   * @property {string} [clientUniqueId]
   */
  constructor() {
  }

  /**
   * Defines the metadata of ReleaseMetadataModel
   *
   * @returns {object} metadata of ReleaseMetadataModel
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'releaseMetadata',
      type: {
        name: 'Composite',
        className: 'ReleaseMetadataModel',
        modelProperties: {
          deploymentKey: {
            required: false,
            serializedName: 'deploymentKey',
            type: {
              name: 'String'
            }
          },
          label: {
            required: false,
            serializedName: 'label',
            type: {
              name: 'String'
            }
          },
          appVersion: {
            required: false,
            serializedName: 'appVersion',
            type: {
              name: 'String'
            }
          },
          previousDeploymentKey: {
            required: false,
            serializedName: 'previousDeploymentKey',
            type: {
              name: 'String'
            }
          },
          previousLabelOrAppVersion: {
            required: false,
            serializedName: 'previousLabelOrAppVersion',
            type: {
              name: 'String'
            }
          },
          status: {
            required: false,
            serializedName: 'status',
            type: {
              name: 'String'
            }
          },
          clientUniqueId: {
            required: false,
            serializedName: 'clientUniqueId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ReleaseMetadataModel;
