/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * An object containing all the release metadata.
 *
 */
class ReleaseUpdateRequestMetadata {
  /**
   * Create a ReleaseUpdateRequestMetadata.
   * @property {string} [dsaSignature] dsa signature of the release for the
   * sparkle feed.
   * @property {string} [edSignature] edDSA signature of the release for the
   * sparkle feed.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ReleaseUpdateRequestMetadata
   *
   * @returns {object} metadata of ReleaseUpdateRequestMetadata
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ReleaseUpdateRequest_metadata',
      type: {
        name: 'Composite',
        className: 'ReleaseUpdateRequestMetadata',
        modelProperties: {
          dsaSignature: {
            required: false,
            serializedName: 'dsa_signature',
            type: {
              name: 'String'
            }
          },
          edSignature: {
            required: false,
            serializedName: 'ed_signature',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ReleaseUpdateRequestMetadata;
