/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Response for updating a release
 *
 */
class ReleaseUpdateResponse {
  /**
   * Create a ReleaseUpdateResponse.
   * @property {boolean} [enabled]
   * @property {boolean} [mandatoryUpdate]
   * @property {string} [releaseNotes]
   * @property {string} [provisioningStatusUrl]
   * @property {array} [destinations]
   */
  constructor() {
  }

  /**
   * Defines the metadata of ReleaseUpdateResponse
   *
   * @returns {object} metadata of ReleaseUpdateResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ReleaseUpdateResponse',
      type: {
        name: 'Composite',
        className: 'ReleaseUpdateResponse',
        modelProperties: {
          enabled: {
            required: false,
            serializedName: 'enabled',
            type: {
              name: 'Boolean'
            }
          },
          mandatoryUpdate: {
            required: false,
            serializedName: 'mandatory_update',
            type: {
              name: 'Boolean'
            }
          },
          releaseNotes: {
            required: false,
            serializedName: 'release_notes',
            type: {
              name: 'String'
            }
          },
          provisioningStatusUrl: {
            required: false,
            serializedName: 'provisioning_status_url',
            type: {
              name: 'String'
            }
          },
          destinations: {
            required: false,
            serializedName: 'destinations',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ReleaseUpdateResponseDestinationsItemElementType',
                  type: {
                    name: 'Composite',
                    className: 'ReleaseUpdateResponseDestinationsItem'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ReleaseUpdateResponse;
