/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a ResetPasswordUsingTokenRequest.
 */
class ResetPasswordUsingTokenRequest {
  /**
   * Create a ResetPasswordUsingTokenRequest.
   * @property {string} newPassword The new password. Needs to be at least 8
   * characters long and contain at least one lower- and one uppercase letter.
   * @property {string} token The reset password token that was sent to the
   * user
   */
  constructor() {
  }

  /**
   * Defines the metadata of ResetPasswordUsingTokenRequest
   *
   * @returns {object} metadata of ResetPasswordUsingTokenRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ResetPasswordUsingTokenRequest',
      type: {
        name: 'Composite',
        className: 'ResetPasswordUsingTokenRequest',
        modelProperties: {
          newPassword: {
            required: true,
            serializedName: 'new_password',
            type: {
              name: 'String'
            }
          },
          token: {
            required: true,
            serializedName: 'token',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ResetPasswordUsingTokenRequest;
