/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a StepReportDeviceScreenshotsItem.
 */
class StepReportDeviceScreenshotsItem {
  /**
   * Create a StepReportDeviceScreenshotsItem.
   * @property {string} [id]
   * @property {string} [deviceSnapshotId]
   * @property {array} [stacktrace]
   * @property {array} [crashData]
   * @property {string} [status]
   * @property {string} [title]
   * @property {object} [screenshot]
   * @property {object} [screenshot.urls]
   * @property {string} [screenshot.urls.original]
   * @property {string} [screenshot.urls.small]
   * @property {string} [screenshot.urls.medium]
   * @property {string} [screenshot.urls.large]
   * @property {number} [screenshot.rotation]
   * @property {boolean} [screenshot.landscape]
   * @property {string} [logFile]
   * @property {string} [appiumLogFile]
   * @property {array} [rawCrashData]
   */
  constructor() {
  }

  /**
   * Defines the metadata of StepReportDeviceScreenshotsItem
   *
   * @returns {object} metadata of StepReportDeviceScreenshotsItem
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'StepReport_deviceScreenshotsItem',
      type: {
        name: 'Composite',
        className: 'StepReportDeviceScreenshotsItem',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          deviceSnapshotId: {
            required: false,
            serializedName: 'device_snapshot_id',
            type: {
              name: 'String'
            }
          },
          stacktrace: {
            required: false,
            serializedName: 'stacktrace',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          crashData: {
            required: false,
            serializedName: 'crash_data',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          status: {
            required: false,
            serializedName: 'status',
            type: {
              name: 'String'
            }
          },
          title: {
            required: false,
            serializedName: 'title',
            type: {
              name: 'String'
            }
          },
          screenshot: {
            required: false,
            serializedName: 'screenshot',
            type: {
              name: 'Composite',
              className: 'StepReportDeviceScreenshotsItemScreenshot'
            }
          },
          logFile: {
            required: false,
            serializedName: 'log_file',
            type: {
              name: 'String'
            }
          },
          appiumLogFile: {
            required: false,
            serializedName: 'appium_log_file',
            type: {
              name: 'String'
            }
          },
          rawCrashData: {
            required: false,
            serializedName: 'raw_crash_data',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = StepReportDeviceScreenshotsItem;
