/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a StoreDestinationDetails.
 */
class StoreDestinationDetails {
  /**
   * Create a StoreDestinationDetails.
   * @property {string} [destPublishId] destination ID identifying a unique id
   * in distribution store.
   * @property {string} [storeType] type of store. Possible values include:
   * 'intune'
   * @property {string} [appId] app id of application.
   */
  constructor() {
  }

  /**
   * Defines the metadata of StoreDestinationDetails
   *
   * @returns {object} metadata of StoreDestinationDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'StoreDestinationDetails',
      type: {
        name: 'Composite',
        className: 'StoreDestinationDetails',
        modelProperties: {
          destPublishId: {
            required: false,
            serializedName: 'dest_publish_id',
            type: {
              name: 'String'
            }
          },
          storeType: {
            required: false,
            serializedName: 'store_type',
            type: {
              name: 'String'
            }
          },
          appId: {
            required: false,
            serializedName: 'appId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = StoreDestinationDetails;
