/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @summary Test Cloud File Hash
  *
 * Hash, type, path and byte range of a file that is required in test run
 *
 */
class TestCloudFileHashDeprecated {
  /**
   * Create a TestCloudFileHashDeprecated.
   * @property {string} fileType Type of the file. Possible values include:
   * 'dsym-file', 'app-file', 'test-file'
   * @property {string} checksum SHA256 hash of the file
   * @property {string} relativePath Relative path of the file
   * @property {string} [byteRange] Range of bytes required to verify ownership
   * of the file
   */
  constructor() {
  }

  /**
   * Defines the metadata of TestCloudFileHashDeprecated
   *
   * @returns {object} metadata of TestCloudFileHashDeprecated
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'TestCloudFileHashDeprecated',
      type: {
        name: 'Composite',
        className: 'TestCloudFileHashDeprecated',
        modelProperties: {
          fileType: {
            required: true,
            serializedName: 'file_type',
            type: {
              name: 'String'
            }
          },
          checksum: {
            required: true,
            serializedName: 'checksum',
            type: {
              name: 'String'
            }
          },
          relativePath: {
            required: true,
            serializedName: 'relative_path',
            type: {
              name: 'String'
            }
          },
          byteRange: {
            required: false,
            serializedName: 'byte_range',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = TestCloudFileHashDeprecated;
