/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @summary Test Cloud File Hash Response
  *
 * Response message for single uploaded file hash
 *
 */
class TestCloudFileHashResponse {
  /**
   * Create a TestCloudFileHashResponse.
   * @property {string} fileType Type of the file. Possible values include:
   * 'dsym-file', 'app-file', 'test-file'
   * @property {string} checksum SHA256 hash of the file
   * @property {string} [relativePath] Relative path of the file
   * @property {object} uploadStatus Test Cloud Hash Upload Status. Status of
   * the upload
   * @property {number} [uploadStatus.statusCode] HTTP status code that
   * represent result of upload
   * @property {string} [uploadStatus.location] URI that should be used to make
   * POST request if file with given hash doesn't exist. This is set when
   * status_code is equal to 412
   */
  constructor() {
  }

  /**
   * Defines the metadata of TestCloudFileHashResponse
   *
   * @returns {object} metadata of TestCloudFileHashResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'TestCloudFileHashResponse',
      type: {
        name: 'Composite',
        className: 'TestCloudFileHashResponse',
        modelProperties: {
          fileType: {
            required: true,
            serializedName: 'fileType',
            type: {
              name: 'String'
            }
          },
          checksum: {
            required: true,
            serializedName: 'checksum',
            type: {
              name: 'String'
            }
          },
          relativePath: {
            required: false,
            serializedName: 'relativePath',
            type: {
              name: 'String'
            }
          },
          uploadStatus: {
            required: true,
            serializedName: 'uploadStatus',
            type: {
              name: 'Composite',
              className: 'TestCloudFileHashResponseUploadStatus'
            }
          }
        }
      }
    };
  }
}

module.exports = TestCloudFileHashResponse;
