/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @summary Test Cloud Test Run Start Result
  *
 * Result of starting a test run
 *
 */
class TestCloudStartTestRunResult {
  /**
   * Create a TestCloudStartTestRunResult.
   * @property {array} [acceptedDevices] List with names of accepted devices
   * @property {array} [rejectedDevices] List with names and descriptions of
   * rejected devices
   */
  constructor() {
  }

  /**
   * Defines the metadata of TestCloudStartTestRunResult
   *
   * @returns {object} metadata of TestCloudStartTestRunResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'TestCloudStartTestRunResult',
      type: {
        name: 'Composite',
        className: 'TestCloudStartTestRunResult',
        modelProperties: {
          acceptedDevices: {
            required: false,
            serializedName: 'accepted_devices',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          rejectedDevices: {
            required: false,
            serializedName: 'rejected_devices',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = TestCloudStartTestRunResult;
