/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a TesterAppWithReleaseResponseRelease.
 */
class TesterAppWithReleaseResponseRelease {
  /**
   * Create a TesterAppWithReleaseResponseRelease.
   * @property {number} id ID identifying this unique release.
   * @property {string} version The release's version.<br>
   * For iOS: CFBundleVersion from info.plist.<br>
   * For Android: android:versionCode from AppManifest.xml.
   * @property {string} [origin] The release's origin. Possible values include:
   * 'hockeyapp', 'appcenter'
   * @property {string} shortVersion The release's short version.<br>
   * For iOS: CFBundleShortVersionString from info.plist.<br>
   * For Android: android:versionName from AppManifest.xml.
   * @property {boolean} mandatoryUpdate A boolean which determines whether the
   * release is a mandatory update or not.
   * @property {string} uploadedAt UTC time in ISO 8601 format of the uploaded
   * time.
   * @property {boolean} enabled This value determines the whether a release
   * currently is enabled or disabled.
   * @property {boolean} [isExternalBuild] This value determines if a release
   * is external or not.
   * @property {number} size The release's size in bytes.
   * @property {string} [installUrl] The href required to install a release on
   * a mobile device. On iOS devices will be prefixed with
   * `itms-services://?action=download-manifest&url=`
   * @property {string} [releaseNotes] The release's release notes.
   */
  constructor() {
  }

  /**
   * Defines the metadata of TesterAppWithReleaseResponseRelease
   *
   * @returns {object} metadata of TesterAppWithReleaseResponseRelease
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'TesterAppWithReleaseResponse_release',
      type: {
        name: 'Composite',
        className: 'TesterAppWithReleaseResponseRelease',
        modelProperties: {
          id: {
            required: true,
            serializedName: 'id',
            type: {
              name: 'Number'
            }
          },
          version: {
            required: true,
            serializedName: 'version',
            type: {
              name: 'String'
            }
          },
          origin: {
            required: false,
            serializedName: 'origin',
            type: {
              name: 'String'
            }
          },
          shortVersion: {
            required: true,
            serializedName: 'short_version',
            type: {
              name: 'String'
            }
          },
          mandatoryUpdate: {
            required: true,
            serializedName: 'mandatory_update',
            type: {
              name: 'Boolean'
            }
          },
          uploadedAt: {
            required: true,
            serializedName: 'uploaded_at',
            type: {
              name: 'String'
            }
          },
          enabled: {
            required: true,
            serializedName: 'enabled',
            type: {
              name: 'Boolean'
            }
          },
          isExternalBuild: {
            required: false,
            serializedName: 'is_external_build',
            type: {
              name: 'Boolean'
            }
          },
          size: {
            required: true,
            serializedName: 'size',
            type: {
              name: 'Number'
            }
          },
          installUrl: {
            required: false,
            serializedName: 'install_url',
            type: {
              name: 'String'
            }
          },
          releaseNotes: {
            required: false,
            serializedName: 'release_notes',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = TesterAppWithReleaseResponseRelease;
