/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * A collection of projects for each type of toolset
 *
 */
class ToolsetProjects {
  /**
   * Create a ToolsetProjects.
   * @property {string} [commit] The commit hash of the analyzed commit
   * @property {object} [xcode]
   * @property {array} [xcode.xcodeSchemeContainers] The Xcode scheme
   * containers
   * @property {object} [javascript]
   * @property {array} [javascript.packageJsonPaths] Paths for detected
   * package.json files
   * @property {array} [javascript.javascriptSolutions] The React Native
   * solutions detected
   * @property {object} [xamarin]
   * @property {array} [xamarin.xamarinSolutions] Xamarin solutions for the
   * toolset
   * @property {object} [android]
   * @property {array} [android.androidModules] Android Gradle modules
   * @property {string} [android.gradleWrapperPath] The path of the Gradle
   * wrapper
   * @property {object} [buildscripts] A collection of detected pre/post
   * buildscripts for current platform toolset
   * @property {object} [uwp]
   * @property {array} [uwp.uwpSolutions] The UWP solutions detected
   * @property {object} [testcloud]
   * @property {array} [testcloud.projects] The TestCloud projects detected
   */
  constructor() {
  }

  /**
   * Defines the metadata of ToolsetProjects
   *
   * @returns {object} metadata of ToolsetProjects
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ToolsetProjects',
      type: {
        name: 'Composite',
        className: 'ToolsetProjects',
        modelProperties: {
          commit: {
            required: false,
            serializedName: 'commit',
            type: {
              name: 'String'
            }
          },
          xcode: {
            required: false,
            serializedName: 'xcode',
            type: {
              name: 'Composite',
              className: 'ToolsetProjectsXcode'
            }
          },
          javascript: {
            required: false,
            serializedName: 'javascript',
            type: {
              name: 'Composite',
              className: 'ToolsetProjectsJavascript'
            }
          },
          xamarin: {
            required: false,
            serializedName: 'xamarin',
            type: {
              name: 'Composite',
              className: 'ToolsetProjectsXamarin'
            }
          },
          android: {
            required: false,
            serializedName: 'android',
            type: {
              name: 'Composite',
              className: 'ToolsetProjectsAndroid'
            }
          },
          buildscripts: {
            required: false,
            serializedName: 'buildscripts',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'ToolsetProjectsBuildscriptsValueElementType',
                  type: {
                    name: 'Composite',
                    className: 'ToolsetProjectsBuildscriptsValue'
                  }
              }
            }
          },
          uwp: {
            required: false,
            serializedName: 'uwp',
            type: {
              name: 'Composite',
              className: 'ToolsetProjectsUwp'
            }
          },
          testcloud: {
            required: false,
            serializedName: 'testcloud',
            type: {
              name: 'Composite',
              className: 'ToolsetProjectsTestcloud'
            }
          }
        }
      }
    };
  }
}

module.exports = ToolsetProjects;
