/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a ToolsetProjectsXcodeXcodeSchemeContainersItemSharedSchemesItem.
 */
class ToolsetProjectsXcodeXcodeSchemeContainersItemSharedSchemesItem {
  /**
   * Create a ToolsetProjectsXcodeXcodeSchemeContainersItemSharedSchemesItem.
   * @property {string} name Scheme name
   * @property {boolean} hasTestAction Does scheme have a test action?
   * @property {string} [archiveConfiguration] Build configuration set in
   * Archive action
   * @property {object} [archiveProject]
   * @property {string} [archiveProject.archiveTargetId] The Id of the target
   * to archive
   * @property {string} [archiveProject.projectName] The project to archive
   * container name
   * @property {string} [archiveProject.projectPath] Full path of the target
   * project
   */
  constructor() {
  }

  /**
   * Defines the metadata of ToolsetProjectsXcodeXcodeSchemeContainersItemSharedSchemesItem
   *
   * @returns {object} metadata of ToolsetProjectsXcodeXcodeSchemeContainersItemSharedSchemesItem
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ToolsetProjects_xcode_xcodeSchemeContainersItem_sharedSchemesItem',
      type: {
        name: 'Composite',
        className: 'ToolsetProjectsXcodeXcodeSchemeContainersItemSharedSchemesItem',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          hasTestAction: {
            required: true,
            serializedName: 'hasTestAction',
            type: {
              name: 'Boolean'
            }
          },
          archiveConfiguration: {
            required: false,
            serializedName: 'archiveConfiguration',
            type: {
              name: 'String'
            }
          },
          archiveProject: {
            required: false,
            serializedName: 'archiveProject',
            type: {
              name: 'Composite',
              className: 'ToolsetProjectsXcodeXcodeSchemeContainersItemSharedSchemesItemArchiveProject'
            }
          }
        }
      }
    };
  }
}

module.exports = ToolsetProjectsXcodeXcodeSchemeContainersItemSharedSchemesItem;
