/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a UpdateBadRequestResponse.
 */
class UpdateBadRequestResponse {
  /**
   * Create a UpdateBadRequestResponse.
   * @property {string} code Possible values include: 'BadRequest', 'Conflict',
   * 'NotAcceptable', 'NotFound', 'InternalServerError', 'Unauthorized',
   * 'TooManyRequests'
   * @property {string} message
   * @property {string} [releaseNotes]
   * @property {boolean} [mandatoryUpdate]
   * @property {array} [destinations]
   */
  constructor() {
  }

  /**
   * Defines the metadata of UpdateBadRequestResponse
   *
   * @returns {object} metadata of UpdateBadRequestResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'UpdateBadRequestResponse',
      type: {
        name: 'Composite',
        className: 'UpdateBadRequestResponse',
        modelProperties: {
          code: {
            required: true,
            serializedName: 'code',
            type: {
              name: 'String'
            }
          },
          message: {
            required: true,
            serializedName: 'message',
            type: {
              name: 'String'
            }
          },
          releaseNotes: {
            required: false,
            serializedName: 'release_notes',
            type: {
              name: 'String'
            }
          },
          mandatoryUpdate: {
            required: false,
            serializedName: 'mandatory_update',
            type: {
              name: 'Boolean'
            }
          },
          destinations: {
            required: false,
            serializedName: 'destinations',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'UpdateBadRequestResponseDestinationsItemElementType',
                  type: {
                    name: 'Composite',
                    className: 'UpdateBadRequestResponseDestinationsItem'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = UpdateBadRequestResponse;
