/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a UpdateCheckResponseUpdateInfo.
 */
class UpdateCheckResponseUpdateInfo {
  /**
   * Create a UpdateCheckResponseUpdateInfo.
   * @property {string} [targetBinaryRange]
   * @property {string} [description]
   * @property {boolean} [isDisabled]
   * @property {boolean} [isMandatory]
   * @property {number} [rollout]
   * @property {string} [downloadUrl]
   * @property {boolean} isAvailable
   * @property {number} [packageSize]
   * @property {boolean} [shouldRunBinaryVersion]
   * @property {boolean} [updateAppVersion]
   * @property {string} [packageHash]
   * @property {string} [label]
   */
  constructor() {
  }

  /**
   * Defines the metadata of UpdateCheckResponseUpdateInfo
   *
   * @returns {object} metadata of UpdateCheckResponseUpdateInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'UpdateCheckResponse_update_info',
      type: {
        name: 'Composite',
        className: 'UpdateCheckResponseUpdateInfo',
        modelProperties: {
          targetBinaryRange: {
            required: false,
            serializedName: 'target_binary_range',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          isDisabled: {
            required: false,
            serializedName: 'is_disabled',
            type: {
              name: 'Boolean'
            }
          },
          isMandatory: {
            required: false,
            serializedName: 'is_mandatory',
            type: {
              name: 'Boolean'
            }
          },
          rollout: {
            required: false,
            serializedName: 'rollout',
            constraints: {
              InclusiveMaximum: 100,
              InclusiveMinimum: 1
            },
            type: {
              name: 'Number'
            }
          },
          downloadUrl: {
            required: false,
            serializedName: 'download_url',
            type: {
              name: 'String'
            }
          },
          isAvailable: {
            required: true,
            serializedName: 'is_available',
            type: {
              name: 'Boolean'
            }
          },
          packageSize: {
            required: false,
            serializedName: 'package_size',
            type: {
              name: 'Number'
            }
          },
          shouldRunBinaryVersion: {
            required: false,
            serializedName: 'should_run_binary_version',
            type: {
              name: 'Boolean'
            }
          },
          updateAppVersion: {
            required: false,
            serializedName: 'update_app_version',
            type: {
              name: 'Boolean'
            }
          },
          packageHash: {
            required: false,
            serializedName: 'package_hash',
            type: {
              name: 'String'
            }
          },
          label: {
            required: false,
            serializedName: 'label',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = UpdateCheckResponseUpdateInfo;
