/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a UserDataResponse.
 */
class UserDataResponse {
  /**
   * Create a UserDataResponse.
   * @property {uuid} [id] The unique id (UUID) of the user
   * @property {string} [displayName] The display name of the user
   * @property {string} [name] The name of the user
   * @property {string} [avatarUrl] The url at which the user's avatar can be
   * reached
   */
  constructor() {
  }

  /**
   * Defines the metadata of UserDataResponse
   *
   * @returns {object} metadata of UserDataResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'UserDataResponse',
      type: {
        name: 'Composite',
        className: 'UserDataResponse',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          displayName: {
            required: false,
            serializedName: 'display_name',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          avatarUrl: {
            required: false,
            serializedName: 'avatar_url',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = UserDataResponse;
