/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Response for retrieving user interaction metrics.
 *
 */
class UserInteractionMetricsResponse {
  /**
   * Create a UserInteractionMetricsResponse.
   * @property {boolean} [lessThan100Apps] check if the user has less than 100
   * apps.
   * @property {boolean} [hasMoreThan1Release] check if the user's whole apps
   * has more than 1 releases.
   */
  constructor() {
  }

  /**
   * Defines the metadata of UserInteractionMetricsResponse
   *
   * @returns {object} metadata of UserInteractionMetricsResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'UserInteractionMetricsResponse',
      type: {
        name: 'Composite',
        className: 'UserInteractionMetricsResponse',
        modelProperties: {
          lessThan100Apps: {
            required: false,
            serializedName: 'less_than_100_apps',
            type: {
              name: 'Boolean'
            }
          },
          hasMoreThan1Release: {
            required: false,
            serializedName: 'has_more_than_1_release',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = UserInteractionMetricsResponse;
