/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a UserProfileResponseManagementIdentityProvidersItem.
 */
class UserProfileResponseManagementIdentityProvidersItem {
  /**
   * Create a UserProfileResponseManagementIdentityProvidersItem.
   * @property {string} [providerName] The name of the identity provider type.
   * Possible values include: 'github', 'aad', 'facebook', 'google'
   * @property {string} [origin] Whether the identity provider originated in
   * HockeyApp or App Center
   */
  constructor() {
  }

  /**
   * Defines the metadata of UserProfileResponseManagementIdentityProvidersItem
   *
   * @returns {object} metadata of UserProfileResponseManagementIdentityProvidersItem
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'UserProfileResponseManagement_identity_providersItem',
      type: {
        name: 'Composite',
        className: 'UserProfileResponseManagementIdentityProvidersItem',
        modelProperties: {
          providerName: {
            required: false,
            serializedName: 'provider_name',
            type: {
              name: 'String'
            }
          },
          origin: {
            required: false,
            serializedName: 'origin',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = UserProfileResponseManagementIdentityProvidersItem;
