/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a UserUpdateRequestInternal.
 */
class UserUpdateRequestInternal {
  /**
   * Create a UserUpdateRequestInternal.
   * @property {string} [displayName] The full name of the user. Might for
   * example be first and last name
   * @property {string} [name] The new, unique name that is used to identify.
   * @property {string} [nextNpsSurveyDate] The date in the future when the
   * user should be checked again for NPS eligibility
   * @property {string} [email] The email address for this user
   */
  constructor() {
  }

  /**
   * Defines the metadata of UserUpdateRequestInternal
   *
   * @returns {object} metadata of UserUpdateRequestInternal
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'UserUpdateRequestInternal',
      type: {
        name: 'Composite',
        className: 'UserUpdateRequestInternal',
        modelProperties: {
          displayName: {
            required: false,
            serializedName: 'display_name',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          nextNpsSurveyDate: {
            required: false,
            serializedName: 'next_nps_survey_date',
            type: {
              name: 'String'
            }
          },
          email: {
            required: false,
            serializedName: 'email',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = UserUpdateRequestInternal;
