/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * VSTS account with projects list and user info
 *
 */
class VSTSAccountsItem {
  /**
   * Create a VSTSAccountsItem.
   * @property {string} [accountId] Account id
   * @property {string} [accountUri] Account uri
   * @property {string} [accountName] Account name
   * @property {string} [accountType] Account type
   * @property {string} [accountStatus] Account status
   * @property {object} [user] VSTS user profile
   * @property {string} [user.id] Profile id
   * @property {string} [user.displayName] Profile display name
   * @property {string} [user.publicAlias] Profile alias
   * @property {string} [user.emailAddress] Profile email
   * @property {array} [projects] Account projects
   */
  constructor() {
  }

  /**
   * Defines the metadata of VSTSAccountsItem
   *
   * @returns {object} metadata of VSTSAccountsItem
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VSTSAccountsItem',
      type: {
        name: 'Composite',
        className: 'VSTSAccountsItem',
        modelProperties: {
          accountId: {
            required: false,
            serializedName: 'accountId',
            type: {
              name: 'String'
            }
          },
          accountUri: {
            required: false,
            serializedName: 'accountUri',
            type: {
              name: 'String'
            }
          },
          accountName: {
            required: false,
            serializedName: 'accountName',
            type: {
              name: 'String'
            }
          },
          accountType: {
            required: false,
            serializedName: 'accountType',
            type: {
              name: 'String'
            }
          },
          accountStatus: {
            required: false,
            serializedName: 'accountStatus',
            type: {
              name: 'String'
            }
          },
          user: {
            required: false,
            serializedName: 'user',
            type: {
              name: 'Composite',
              className: 'VSTSAccountsItemUser'
            }
          },
          projects: {
            required: false,
            serializedName: 'projects',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'VSTSAccountsItemProjectsItemElementType',
                  type: {
                    name: 'Composite',
                    className: 'VSTSAccountsItemProjectsItem'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = VSTSAccountsItem;
