/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a ValidatedApiTokenResponse.
 */
class ValidatedApiTokenResponse {
  /**
   * Create a ValidatedApiTokenResponse.
   * @property {uuid} tokenId The token's unique id (UUID)
   * @property {array} tokenScope The token's scope. A list of allowed roles.
   * @property {uuid} principalId The ID of the owner of the API Token (user_id
   * or app_id)
   * @property {string} principalType Indicates the type of the principal (app
   * or user). Possible values include: 'app', 'user'
   * @property {array} claims Collection of attributes that describe the
   * principal of the specified API Token
   */
  constructor() {
  }

  /**
   * Defines the metadata of ValidatedApiTokenResponse
   *
   * @returns {object} metadata of ValidatedApiTokenResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ValidatedApiTokenResponse',
      type: {
        name: 'Composite',
        className: 'ValidatedApiTokenResponse',
        modelProperties: {
          tokenId: {
            required: true,
            serializedName: 'token_id',
            type: {
              name: 'String'
            }
          },
          tokenScope: {
            required: true,
            serializedName: 'token_scope',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          principalId: {
            required: true,
            serializedName: 'principal_id',
            type: {
              name: 'String'
            }
          },
          principalType: {
            required: true,
            serializedName: 'principal_type',
            type: {
              name: 'String'
            }
          },
          claims: {
            required: true,
            serializedName: 'claims',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ValidatedApiTokenResponseClaimsItemElementType',
                  type: {
                    name: 'Composite',
                    className: 'ValidatedApiTokenResponseClaimsItem'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ValidatedApiTokenResponse;
