/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The response which contains the validation data that the connection is
 * valid.
 *
 */
class ValidationResponse {
  /**
   * Create a ValidationResponse.
   * @property {string} [appId] app id
   * @property {object} [status] Status Data from store
   * @property {string} [status.status] status from store
   * @property {string} [status.storetype] store type
   * @property {string} [status.track] track information from store
   * @property {string} [status.version] version of the app from store
   */
  constructor() {
  }

  /**
   * Defines the metadata of ValidationResponse
   *
   * @returns {object} metadata of ValidationResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ValidationResponse',
      type: {
        name: 'Composite',
        className: 'ValidationResponse',
        modelProperties: {
          appId: {
            required: false,
            serializedName: 'app_id',
            type: {
              name: 'String'
            }
          },
          status: {
            required: false,
            serializedName: 'status',
            type: {
              name: 'Composite',
              className: 'ValidationResponseStatus'
            }
          }
        }
      }
    };
  }
}

module.exports = ValidationResponse;
