/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Billing Plan with a version
 *
 */
class VersionedBillingPlan {
  /**
   * Create a VersionedBillingPlan.
   * @property {object} [document] Billing Plan
   * @property {string} [document.id] The Billing Plan ID
   * @property {string} [document.version] Version of the Billing Plan schema
   * @property {number} [document.price] Price of the Billing Plan
   * @property {string} [document.paymentSource] Service that receives payments
   * for this billing plan. Possible values include: 'None', 'AppCenter',
   * 'GitHub', 'Xtc'
   * @property {string} [document.service] Name of the service that the plan
   * applies to. Possible values include: 'Build', 'Test'
   * @property {object} [document.limits] A collection of named numeric values
   * @property {object} [document.attributes] Collection of attribute values.
   * @property {string} [document.parentId]
   * @property {string} [etag] The version of the object
   */
  constructor() {
  }

  /**
   * Defines the metadata of VersionedBillingPlan
   *
   * @returns {object} metadata of VersionedBillingPlan
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VersionedBillingPlan',
      type: {
        name: 'Composite',
        className: 'VersionedBillingPlan',
        modelProperties: {
          document: {
            required: false,
            serializedName: 'document',
            type: {
              name: 'Composite',
              className: 'VersionedBillingPlanDocument'
            }
          },
          etag: {
            required: false,
            serializedName: 'etag',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = VersionedBillingPlan;
