/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Build configuration when Xcode is part of the build steps
 *
 */
class XcodeBranchConfigurationProperties {
  /**
   * Create a XcodeBranchConfigurationProperties.
   * @property {string} [projectOrWorkspacePath] Xcode project/workspace path
   * @property {string} [podfilePath] Path to CococaPods file, if present
   * @property {string} [cartfilePath] Path to Carthage file, if present
   * @property {string} [provisioningProfileEncoded]
   * @property {string} [certificateEncoded]
   * @property {string} [provisioningProfileFileId]
   * @property {string} [certificateFileId]
   * @property {string} [provisioningProfileUploadId]
   * @property {array} [appExtensionProvisioningProfileFiles]
   * @property {string} [certificateUploadId]
   * @property {string} [certificatePassword]
   * @property {string} [scheme]
   * @property {string} [xcodeVersion] Xcode version used to build. Available
   * versions can be found in "/xcode_versions" API. Default is latest stable
   * version, at the time when the configuration is set.
   * @property {string} [provisioningProfileFilename]
   * @property {string} [certificateFilename]
   * @property {string} [teamId]
   * @property {boolean} [automaticSigning]
   * @property {string} [xcodeProjectSha] The selected pbxproject hash to the
   * repositroy
   * @property {string} [archiveConfiguration] The build configuration of the
   * target to archive
   * @property {string} [targetToArchive] The target id of the selected scheme
   * to archive
   * @property {boolean} [forceLegacyBuildSystem] Setting this to true forces
   * the build to use Xcode legacy build system. Otherwise, the setting from
   * workspace settings is used.
   * By default new build system is used if workspace setting is not committed
   * to the repository. Only used for iOS React Native app, with Xcode 10.
   */
  constructor() {
  }

  /**
   * Defines the metadata of XcodeBranchConfigurationProperties
   *
   * @returns {object} metadata of XcodeBranchConfigurationProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'XcodeBranchConfigurationProperties',
      type: {
        name: 'Composite',
        className: 'XcodeBranchConfigurationProperties',
        modelProperties: {
          projectOrWorkspacePath: {
            required: false,
            serializedName: 'projectOrWorkspacePath',
            type: {
              name: 'String'
            }
          },
          podfilePath: {
            required: false,
            serializedName: 'podfilePath',
            type: {
              name: 'String'
            }
          },
          cartfilePath: {
            required: false,
            serializedName: 'cartfilePath',
            type: {
              name: 'String'
            }
          },
          provisioningProfileEncoded: {
            required: false,
            serializedName: 'provisioningProfileEncoded',
            type: {
              name: 'String'
            }
          },
          certificateEncoded: {
            required: false,
            serializedName: 'certificateEncoded',
            type: {
              name: 'String'
            }
          },
          provisioningProfileFileId: {
            required: false,
            serializedName: 'provisioningProfileFileId',
            type: {
              name: 'String'
            }
          },
          certificateFileId: {
            required: false,
            serializedName: 'certificateFileId',
            type: {
              name: 'String'
            }
          },
          provisioningProfileUploadId: {
            required: false,
            serializedName: 'provisioningProfileUploadId',
            type: {
              name: 'String'
            }
          },
          appExtensionProvisioningProfileFiles: {
            required: false,
            serializedName: 'appExtensionProvisioningProfileFiles',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'XcodeBranchConfigurationPropertiesAppExtensionProvisioningProfileFilesItemElementType',
                  type: {
                    name: 'Composite',
                    className: 'XcodeBranchConfigurationPropertiesAppExtensionProvisioningProfileFilesItem'
                  }
              }
            }
          },
          certificateUploadId: {
            required: false,
            serializedName: 'certificateUploadId',
            type: {
              name: 'String'
            }
          },
          certificatePassword: {
            required: false,
            serializedName: 'certificatePassword',
            type: {
              name: 'String'
            }
          },
          scheme: {
            required: false,
            serializedName: 'scheme',
            type: {
              name: 'String'
            }
          },
          xcodeVersion: {
            required: false,
            serializedName: 'xcodeVersion',
            type: {
              name: 'String'
            }
          },
          provisioningProfileFilename: {
            required: false,
            serializedName: 'provisioningProfileFilename',
            type: {
              name: 'String'
            }
          },
          certificateFilename: {
            required: false,
            serializedName: 'certificateFilename',
            type: {
              name: 'String'
            }
          },
          teamId: {
            required: false,
            serializedName: 'teamId',
            type: {
              name: 'String'
            }
          },
          automaticSigning: {
            required: false,
            serializedName: 'automaticSigning',
            type: {
              name: 'Boolean'
            }
          },
          xcodeProjectSha: {
            required: false,
            serializedName: 'xcodeProjectSha',
            type: {
              name: 'String'
            }
          },
          archiveConfiguration: {
            required: false,
            serializedName: 'archiveConfiguration',
            type: {
              name: 'String'
            }
          },
          targetToArchive: {
            required: false,
            serializedName: 'targetToArchive',
            type: {
              name: 'String'
            }
          },
          forceLegacyBuildSystem: {
            required: false,
            serializedName: 'forceLegacyBuildSystem',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = XcodeBranchConfigurationProperties;
