"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.globSingleFile = exports.glob = void 0;
const g = require("glob");
function glob(pattern, options) {
    return new Promise((resolve, reject) => {
        g(pattern, options, (err, matches) => {
            if (err) {
                reject(err);
            }
            else {
                resolve(matches);
            }
        });
    });
}
exports.glob = glob;
function globSingleFile(pattern, options) {
    return new Promise((resolve, reject) => {
        g(pattern, options, (err, matches) => {
            if (err) {
                reject(err);
            }
            if (matches.length === 0) {
                reject(new Error(`Cannot find any file that matches pattern "${pattern}"`));
            }
            else if (matches.length > 1) {
                reject(new Error(`Found more than one file that matches pattern "${pattern}`));
            }
            else {
                resolve(matches[0]);
            }
        });
    });
}
exports.globSingleFile = globSingleFile;
