"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getToFile = void 0;
const https = require("https");
const fs = require("fs");
function getToFile(url, filePath) {
    return __awaiter(this, void 0, void 0, function* () {
        return new Promise((resolve, reject) => {
            // Workaround for incorrect typings, get method is missing string as option for first parameter
            https
                .get(url, (response) => {
                const fileStream = fs.createWriteStream(filePath);
                response.pipe(fileStream);
                fileStream.on("finish", () => {
                    fileStream.close();
                    resolve();
                });
            })
                .on("error", (err) => {
                fs.unlink(filePath, function (failed) {
                    if (failed) {
                        console.error(failed);
                    }
                });
                reject(err);
            });
        });
    });
}
exports.getToFile = getToFile;
